/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 30 "core/cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#ifdef SHM_MEM
#include "shm_init.h"
#endif /* SHM_MEM */
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp;
static int i_tmp;
static struct socket_id* lst_tmp;
static struct name_lst*  nl_tmp;
static int rt;  /* Type of route block for find_export */
static str* str_tmp;
static str s_tmp;
static struct ip_addr* ip_tmp;
static struct avp_spec* s_attr;
static select_t sel;
static select_t* sel_ptr;
static pv_spec_t* pv_spec;
static struct action *mod_func_action;
static struct lvalue* lval_tmp;
static struct rvalue* rval_tmp;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re, 
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 234 "core/cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CORE_CFG_TAB_H_INCLUDED
# define YY_YY_CORE_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    FORWARD_TCP = 259,
    FORWARD_TLS = 260,
    FORWARD_SCTP = 261,
    FORWARD_UDP = 262,
    EXIT = 263,
    DROP = 264,
    RETURN = 265,
    BREAK = 266,
    LOG_TOK = 267,
    ERROR = 268,
    ROUTE = 269,
    ROUTE_REQUEST = 270,
    ROUTE_FAILURE = 271,
    ROUTE_ONREPLY = 272,
    ROUTE_REPLY = 273,
    ROUTE_BRANCH = 274,
    ROUTE_SEND = 275,
    ROUTE_EVENT = 276,
    EXEC = 277,
    SET_HOST = 278,
    SET_HOSTPORT = 279,
    SET_HOSTPORTTRANS = 280,
    PREFIX = 281,
    STRIP = 282,
    STRIP_TAIL = 283,
    SET_USERPHONE = 284,
    APPEND_BRANCH = 285,
    REMOVE_BRANCH = 286,
    CLEAR_BRANCHES = 287,
    SET_USER = 288,
    SET_USERPASS = 289,
    SET_PORT = 290,
    SET_URI = 291,
    REVERT_URI = 292,
    FORCE_RPORT = 293,
    ADD_LOCAL_RPORT = 294,
    FORCE_TCP_ALIAS = 295,
    UDP_MTU = 296,
    UDP_MTU_TRY_PROTO = 297,
    UDP4_RAW = 298,
    UDP4_RAW_MTU = 299,
    UDP4_RAW_TTL = 300,
    IF = 301,
    ELSE = 302,
    SET_ADV_ADDRESS = 303,
    SET_ADV_PORT = 304,
    FORCE_SEND_SOCKET = 305,
    SET_FWD_NO_CONNECT = 306,
    SET_RPL_NO_CONNECT = 307,
    SET_FWD_CLOSE = 308,
    SET_RPL_CLOSE = 309,
    SWITCH = 310,
    CASE = 311,
    DEFAULT = 312,
    WHILE = 313,
    CFG_SELECT = 314,
    CFG_RESET = 315,
    URIHOST = 316,
    URIPORT = 317,
    MAX_LEN = 318,
    SETFLAG = 319,
    RESETFLAG = 320,
    ISFLAGSET = 321,
    SETAVPFLAG = 322,
    RESETAVPFLAG = 323,
    ISAVPFLAGSET = 324,
    METHOD = 325,
    URI = 326,
    FROM_URI = 327,
    TO_URI = 328,
    SRCIP = 329,
    SRCPORT = 330,
    DSTIP = 331,
    DSTPORT = 332,
    TOIP = 333,
    TOPORT = 334,
    SNDIP = 335,
    SNDPORT = 336,
    SNDPROTO = 337,
    SNDAF = 338,
    PROTO = 339,
    AF = 340,
    MYSELF = 341,
    MSGLEN = 342,
    UDP = 343,
    TCP = 344,
    TLS = 345,
    SCTP = 346,
    WS = 347,
    WSS = 348,
    DEBUG_V = 349,
    FORK = 350,
    FORK_DELAY = 351,
    MODINIT_DELAY = 352,
    LOGSTDERROR = 353,
    LOGFACILITY = 354,
    LOGNAME = 355,
    LOGCOLOR = 356,
    LOGPREFIX = 357,
    LOGPREFIXMODE = 358,
    LOGENGINETYPE = 359,
    LOGENGINEDATA = 360,
    XAVPVIAPARAMS = 361,
    XAVPVIAFIELDS = 362,
    LISTEN = 363,
    ADVERTISE = 364,
    ALIAS = 365,
    SR_AUTO_ALIASES = 366,
    DNS = 367,
    REV_DNS = 368,
    DNS_TRY_IPV6 = 369,
    DNS_TRY_NAPTR = 370,
    DNS_SRV_LB = 371,
    DNS_UDP_PREF = 372,
    DNS_TCP_PREF = 373,
    DNS_TLS_PREF = 374,
    DNS_SCTP_PREF = 375,
    DNS_RETR_TIME = 376,
    DNS_RETR_NO = 377,
    DNS_SERVERS_NO = 378,
    DNS_USE_SEARCH = 379,
    DNS_SEARCH_FMATCH = 380,
    DNS_NAPTR_IGNORE_RFC = 381,
    DNS_CACHE_INIT = 382,
    DNS_USE_CACHE = 383,
    DNS_USE_FAILOVER = 384,
    DNS_CACHE_FLAGS = 385,
    DNS_CACHE_NEG_TTL = 386,
    DNS_CACHE_MIN_TTL = 387,
    DNS_CACHE_MAX_TTL = 388,
    DNS_CACHE_MEM = 389,
    DNS_CACHE_GC_INT = 390,
    DNS_CACHE_DEL_NONEXP = 391,
    DNS_CACHE_REC_PREF = 392,
    AUTO_BIND_IPV6 = 393,
    DST_BLST_INIT = 394,
    USE_DST_BLST = 395,
    DST_BLST_MEM = 396,
    DST_BLST_TTL = 397,
    DST_BLST_GC_INT = 398,
    DST_BLST_UDP_IMASK = 399,
    DST_BLST_TCP_IMASK = 400,
    DST_BLST_TLS_IMASK = 401,
    DST_BLST_SCTP_IMASK = 402,
    IP_FREE_BIND = 403,
    PORT = 404,
    STAT = 405,
    CHILDREN = 406,
    SOCKET_WORKERS = 407,
    ASYNC_WORKERS = 408,
    ASYNC_USLEEP = 409,
    ASYNC_NONBLOCK = 410,
    CHECK_VIA = 411,
    PHONE2TEL = 412,
    MEMLOG = 413,
    MEMDBG = 414,
    MEMSUM = 415,
    MEMSAFETY = 416,
    MEMJOIN = 417,
    MEMSTATUSMODE = 418,
    CORELOG = 419,
    SIP_WARNING = 420,
    SERVER_SIGNATURE = 421,
    SERVER_HEADER = 422,
    USER_AGENT_HEADER = 423,
    REPLY_TO_VIA = 424,
    LOADMODULE = 425,
    LOADPATH = 426,
    MODPARAM = 427,
    CFGENGINE = 428,
    MAXBUFFER = 429,
    SQL_BUFFER_SIZE = 430,
    USER = 431,
    GROUP = 432,
    CHROOT = 433,
    WDIR = 434,
    RUNDIR = 435,
    MHOMED = 436,
    DISABLE_TCP = 437,
    TCP_ACCEPT_ALIASES = 438,
    TCP_CHILDREN = 439,
    TCP_CONNECT_TIMEOUT = 440,
    TCP_SEND_TIMEOUT = 441,
    TCP_CON_LIFETIME = 442,
    TCP_POLL_METHOD = 443,
    TCP_MAX_CONNECTIONS = 444,
    TLS_MAX_CONNECTIONS = 445,
    TCP_NO_CONNECT = 446,
    TCP_SOURCE_IPV4 = 447,
    TCP_SOURCE_IPV6 = 448,
    TCP_OPT_FD_CACHE = 449,
    TCP_OPT_BUF_WRITE = 450,
    TCP_OPT_CONN_WQ_MAX = 451,
    TCP_OPT_WQ_MAX = 452,
    TCP_OPT_RD_BUF = 453,
    TCP_OPT_WQ_BLK = 454,
    TCP_OPT_DEFER_ACCEPT = 455,
    TCP_OPT_DELAYED_ACK = 456,
    TCP_OPT_SYNCNT = 457,
    TCP_OPT_LINGER2 = 458,
    TCP_OPT_KEEPALIVE = 459,
    TCP_OPT_KEEPIDLE = 460,
    TCP_OPT_KEEPINTVL = 461,
    TCP_OPT_KEEPCNT = 462,
    TCP_OPT_CRLF_PING = 463,
    TCP_OPT_ACCEPT_NO_CL = 464,
    TCP_OPT_ACCEPT_HEP3 = 465,
    TCP_CLONE_RCVBUF = 466,
    TCP_REUSE_PORT = 467,
    DISABLE_TLS = 468,
    ENABLE_TLS = 469,
    TLSLOG = 470,
    TLS_PORT_NO = 471,
    TLS_METHOD = 472,
    TLS_HANDSHAKE_TIMEOUT = 473,
    TLS_SEND_TIMEOUT = 474,
    SSLv23 = 475,
    SSLv2 = 476,
    SSLv3 = 477,
    TLSv1 = 478,
    TLS_VERIFY = 479,
    TLS_REQUIRE_CERTIFICATE = 480,
    TLS_CERTIFICATE = 481,
    TLS_PRIVATE_KEY = 482,
    TLS_CA_LIST = 483,
    DISABLE_SCTP = 484,
    ENABLE_SCTP = 485,
    SCTP_CHILDREN = 486,
    ADVERTISED_ADDRESS = 487,
    ADVERTISED_PORT = 488,
    DISABLE_CORE = 489,
    OPEN_FD_LIMIT = 490,
    SHM_MEM_SZ = 491,
    SHM_FORCE_ALLOC = 492,
    MLOCK_PAGES = 493,
    REAL_TIME = 494,
    RT_PRIO = 495,
    RT_POLICY = 496,
    RT_TIMER1_PRIO = 497,
    RT_TIMER1_POLICY = 498,
    RT_TIMER2_PRIO = 499,
    RT_TIMER2_POLICY = 500,
    MCAST_LOOPBACK = 501,
    MCAST_TTL = 502,
    MCAST = 503,
    TOS = 504,
    PMTU_DISCOVERY = 505,
    KILL_TIMEOUT = 506,
    MAX_WLOOPS = 507,
    PVBUFSIZE = 508,
    PVBUFSLOTS = 509,
    PVCACHELIMIT = 510,
    PVCACHEACTION = 511,
    HTTP_REPLY_PARSE = 512,
    VERSION_TABLE_CFG = 513,
    VERBOSE_STARTUP = 514,
    ROUTE_LOCKS_SIZE = 515,
    CFG_DESCRIPTION = 516,
    SERVER_ID = 517,
    KEMI = 518,
    ONSEND_ROUTE_CALLBACK = 519,
    REPLY_ROUTE_CALLBACK = 520,
    EVENT_ROUTE_CALLBACK = 521,
    MAX_RECURSIVE_LEVEL = 522,
    MAX_BRANCHES_PARAM = 523,
    LATENCY_CFG_LOG = 524,
    LATENCY_LOG = 525,
    LATENCY_LIMIT_DB = 526,
    LATENCY_LIMIT_ACTION = 527,
    MSG_TIME = 528,
    ONSEND_RT_REPLY = 529,
    FLAGS_DECL = 530,
    AVPFLAGS_DECL = 531,
    ATTR_MARK = 532,
    SELECT_MARK = 533,
    ATTR_FROM = 534,
    ATTR_TO = 535,
    ATTR_FROMURI = 536,
    ATTR_TOURI = 537,
    ATTR_FROMUSER = 538,
    ATTR_TOUSER = 539,
    ATTR_FROMDOMAIN = 540,
    ATTR_TODOMAIN = 541,
    ATTR_GLOBAL = 542,
    ADDEQ = 543,
    SUBST = 544,
    SUBSTDEF = 545,
    SUBSTDEFS = 546,
    EQUAL = 547,
    LOG_OR = 548,
    LOG_AND = 549,
    BIN_OR = 550,
    BIN_AND = 551,
    BIN_XOR = 552,
    BIN_LSHIFT = 553,
    BIN_RSHIFT = 554,
    EQUAL_T = 555,
    DIFF = 556,
    MATCH = 557,
    INTEQ = 558,
    INTDIFF = 559,
    STREQ = 560,
    STRDIFF = 561,
    GT = 562,
    LT = 563,
    GTE = 564,
    LTE = 565,
    PLUS = 566,
    MINUS = 567,
    STAR = 568,
    SLASH = 569,
    MODULO = 570,
    NOT = 571,
    UNARY = 572,
    BIN_NOT = 573,
    DEFINED = 574,
    INTCAST = 575,
    STRCAST = 576,
    DOT = 577,
    STRLEN = 578,
    STREMPTY = 579,
    NUMBER = 580,
    ID = 581,
    NUM_ID = 582,
    STRING = 583,
    IPV6ADDR = 584,
    PVAR = 585,
    AVP_OR_PVAR = 586,
    EVENT_RT_NAME = 587,
    COMMA = 588,
    SEMICOLON = 589,
    RPAREN = 590,
    LPAREN = 591,
    LBRACE = 592,
    RBRACE = 593,
    LBRACK = 594,
    RBRACK = 595,
    CR = 596,
    COLON = 597
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 198 "core/cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;

#line 636 "core/cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CORE_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 653 "core/cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  451
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11735

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  343
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  889
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1660

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   597

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   619,   619,   622,   623,   624,   627,   628,   629,   630,
     631,   632,   632,   633,   633,   634,   635,   635,   636,   636,
     637,   637,   638,   639,   642,   658,   666,   680,   681,   687,
     688,   692,   693,   694,   695,   696,   699,   700,   701,   702,
     703,   704,   705,   708,   709,   712,   713,   714,   715,   716,
     720,   721,   722,   723,   724,   728,   729,   732,   733,   736,
     737,   739,   740,   743,   746,   752,   753,   757,   758,   761,
     762,   765,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   782,   783,   789,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   805,   806,   809,
     810,   811,   812,   813,   814,   815,   816,   817,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   870,   871,   874,
     875,   878,   879,   880,   881,   884,   885,   888,   889,   892,
     893,   896,   897,   898,   899,   900,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   943,   944,   951,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   980,   981,   988,   989,   996,   997,  1004,  1005,  1012,
    1013,  1023,  1024,  1038,  1052,  1053,  1060,  1061,  1068,  1069,
    1076,  1077,  1086,  1087,  1096,  1097,  1104,  1105,  1112,  1113,
    1120,  1121,  1128,  1129,  1136,  1137,  1144,  1145,  1152,  1153,
    1160,  1161,  1168,  1169,  1176,  1177,  1184,  1185,  1192,  1193,
    1200,  1201,  1208,  1209,  1216,  1217,  1224,  1225,  1232,  1234,
    1241,  1242,  1253,  1254,  1261,  1262,  1269,  1270,  1277,  1278,
    1285,  1286,  1293,  1300,  1307,  1314,  1321,  1328,  1329,  1336,
    1337,  1344,  1345,  1352,  1353,  1360,  1361,  1368,  1369,  1376,
    1377,  1384,  1385,  1392,  1393,  1400,  1401,  1402,  1403,  1406,
    1407,  1410,  1411,  1412,  1413,  1425,  1438,  1440,  1451,  1452,
    1453,  1454,  1460,  1461,  1471,  1472,  1473,  1474,  1475,  1476,
    1483,  1484,  1491,  1492,  1493,  1494,  1495,  1496,  1497,  1498,
    1499,  1500,  1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,
    1515,  1516,  1523,  1524,  1531,  1538,  1539,  1540,  1567,  1568,
    1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,
    1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,
    1589,  1590,  1599,  1600,  1609,  1610,  1619,  1620,  1621,  1622,
    1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,
    1633,  1634,  1635,  1636,  1638,  1639,  1641,  1643,  1644,  1645,
    1648,  1649,  1652,  1653,  1654,  1657,  1658,  1661,  1662,  1663,
    1671,  1676,  1681,  1686,  1691,  1694,  1699,  1707,  1713,  1714,
    1724,  1725,  1735,  1736,  1747,  1758,  1759,  1765,  1766,  1772,
    1776,  1777,  1780,  1809,  1824,  1825,  1829,  1840,  1841,  1845,
    1846,  1850,  1859,  1877,  1878,  1881,  1884,  1893,  1911,  1915,
    1916,  1921,  1921,  1930,  1931,  1933,  1932,  1957,  1962,  1965,
    1974,  1992,  1995,  1998,  2007,  2025,  2028,  2031,  2050,  2053,
    2054,  2055,  2056,  2057,  2058,  2080,  2081,  2082,  2083,  2086,
    2087,  2088,  2089,  2092,  2093,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2108,  2109,  2110,  2111,  2118,  2119,  2120,  2127,
    2128,  2129,  2133,  2134,  2135,  2136,  2137,  2142,  2143,  2146,
    2147,  2148,  2154,  2156,  2158,  2159,  2161,  2163,  2165,  2167,
    2169,  2170,  2172,  2173,  2174,  2175,  2177,  2179,  2181,  2183,
    2185,  2187,  2188,  2224,  2226,  2228,  2230,  2233,  2235,  2237,
    2239,  2243,  2244,  2255,  2256,  2260,  2261,  2277,  2293,  2294,
    2297,  2298,  2299,  2308,  2309,  2325,  2341,  2343,  2350,  2392,
    2393,  2396,  2397,  2398,  2401,  2402,  2403,  2404,  2405,  2406,
    2407,  2408,  2411,  2419,  2429,  2446,  2453,  2460,  2467,  2474,
    2479,  2484,  2485,  2486,  2487,  2488,  2491,  2500,  2507,  2532,
    2548,  2549,  2554,  2573,  2582,  2594,  2609,  2610,  2613,  2613,
    2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2634,
    2637,  2638,  2641,  2648,  2651,  2658,  2664,  2665,  2674,  2675,
    2676,  2679,  2680,  2692,  2716,  2727,  2758,  2762,  2772,  2786,
    2798,  2799,  2801,  2802,  2803,  2817,  2818,  2819,  2820,  2821,
    2822,  2823,  2827,  2828,  2829,  2842,  2848,  2849,  2850,  2851,
    2852,  2853,  2854,  2855,  2856,  2857,  2858,  2859,  2860,  2861,
    2862,  2880,  2881,  2882,  2883,  2884,  2885,  2886,  2887,  2888,
    2889,  2890,  2891,  2892,  2893,  2894,  2895,  2896,  2898,  2900,
    2901,  2902,  2903,  2904,  2907,  2925,  2926,  2927,  2930,  2931,
    2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,  2941,
    2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,  2961,
    2962,  2963,  2964,  2972,  2980,  2988,  2996,  3004,  3012,  3020,
    3028,  3036,  3037,  3039,  3047,  3055,  3063,  3072,  3081,  3090,
    3098,  3107,  3115,  3116,  3118,  3121,  3122,  3123,  3124,  3131,
    3138,  3139,  3145,  3152,  3153,  3159,  3166,  3167,  3173,  3176,
    3179,  3180,  3181,  3184,  3185,  3186,  3195,  3204,  3205,  3206,
    3207,  3208,  3209,  3210,  3211,  3212,  3213,  3214,  3215,  3216,
    3217,  3218,  3219,  3220,  3221,  3225,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,
    3243,  3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,
    3253,  3254,  3255,  3256,  3264,  3272,  3280,  3281,  3283,  3285,
    3296,  3297,  3298,  3314,  3315,  3316,  3320,  3323,  3324,  3327,
    3330,  3333,  3336,  3339,  3342,  3345,  3348,  3351,  3354,  3355,
    3356,  3359,  3360,  3361,  3361,  3387,  3389,  3391,  3392,  3395,
    3412,  3416,  3420,  3424,  3429,  3433,  3438,  3442,  3446,  3450
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW",
  "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS",
  "SET_ADV_PORT", "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT",
  "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE",
  "DEFAULT", "WHILE", "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT",
  "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V", "FORK", "FORK_DELAY",
  "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "LOGCOLOR",
  "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE", "LOGENGINEDATA",
  "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE", "ALIAS",
  "SR_AUTO_ALIASES", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF", "DNS_TLS_PREF",
  "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO",
  "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH", "DNS_NAPTR_IGNORE_RFC",
  "DNS_CACHE_INIT", "DNS_USE_CACHE", "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS",
  "DNS_CACHE_NEG_TTL", "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL",
  "DNS_CACHE_MEM", "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP",
  "DNS_CACHE_REC_PREF", "AUTO_BIND_IPV6", "DST_BLST_INIT", "USE_DST_BLST",
  "DST_BLST_MEM", "DST_BLST_TTL", "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK",
  "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK",
  "IP_FREE_BIND", "PORT", "STAT", "CHILDREN", "SOCKET_WORKERS",
  "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK", "CHECK_VIA",
  "PHONE2TEL", "MEMLOG", "MEMDBG", "MEMSUM", "MEMSAFETY", "MEMJOIN",
  "MEMSTATUSMODE", "CORELOG", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "REPLY_TO_VIA", "LOADMODULE",
  "LOADPATH", "MODPARAM", "CFGENGINE", "MAXBUFFER", "SQL_BUFFER_SIZE",
  "USER", "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP",
  "TCP_ACCEPT_ALIASES", "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT",
  "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME", "TCP_POLL_METHOD",
  "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT",
  "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE",
  "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX",
  "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT",
  "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2",
  "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL",
  "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL",
  "TCP_OPT_ACCEPT_HEP3", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "DISABLE_TLS", "ENABLE_TLS", "TLSLOG", "TLS_PORT_NO", "TLS_METHOD",
  "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3",
  "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE",
  "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP",
  "SCTP_CHILDREN", "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE",
  "OPEN_FD_LIMIT", "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES",
  "REAL_TIME", "RT_PRIO", "RT_POLICY", "RT_TIMER1_PRIO",
  "RT_TIMER1_POLICY", "RT_TIMER2_PRIO", "RT_TIMER2_POLICY",
  "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS", "PMTU_DISCOVERY",
  "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE", "PVBUFSLOTS", "PVCACHELIMIT",
  "PVCACHEACTION", "HTTP_REPLY_PARSE", "VERSION_TABLE_CFG",
  "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE", "CFG_DESCRIPTION", "SERVER_ID",
  "KEMI", "ONSEND_ROUTE_CALLBACK", "REPLY_ROUTE_CALLBACK",
  "EVENT_ROUTE_CALLBACK", "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM",
  "LATENCY_CFG_LOG", "LATENCY_LOG", "LATENCY_LIMIT_DB",
  "LATENCY_LIMIT_ACTION", "MSG_TIME", "ONSEND_RT_REPLY", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR", "AVP_OR_PVAR",
  "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE",
  "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "assign_stm", "cfg_var_id", "cfg_var_idn", "cfg_var",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "route_name",
  "route_main", "route_stm", "failure_route_main", "failure_route_stm",
  "route_reply_main", "onreply_route_stm", "$@6", "$@7",
  "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597
};
# endif

#define YYPACT_NINF -1136

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1136)))

#define YYTABLE_NINF -874

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2348,  -256,     8,     9,  -234,  -149,  -138,  -132,  -128,  -121,
   -1136,  -106,   -98,   -93,   -76,   -73,   -68,   -57,   -54,   -41,
      28,    95,   131,   395,   417,   428,   433,   494,   509,   518,
      25,    43,   298,   303,   657,   661,   709,   721,   772,   781,
     787,   822,   846,   864,   885,   894,   895,   903,   907,   908,
     909,   920,   933,   936,   937,   939,   940,   946,   947,   949,
     950,   951,   958,   966,   519,   538,   552,   563,   566,   589,
     592,   593,   597,   601,   602,   665,   676,   714,   716,   744,
     766,   769,   782,   798,   830,   831,    60,    29,    37,   231,
     848,   849,   863,   871,   882,   886,   889,   890,   896,   905,
     906,   910,   917,   924,   925,   944,   945,   955,   970,   980,
     997,  1031,   974,   976,   978,   982,  1032,  1035,  1036,  1042,
    1045,  1049,  1053,  1058,  1059,  1090,  1092,  1093,  1094,  1095,
    1099,  1101,  1102,  1104,  1105,  1130,  1135,  1136,  1147,  1148,
    1154,  1155,  1156,  1157,  1158,  1159,  1161,  1162,  1164,  1165,
    1166,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,
    1176,  1177,   988,  1178,  1181,  1183,  1184,  1185,  1186,  1187,
    1188,  1189,  1191,  1218,  -258,  1219,  1225,  1226,  1227,  1228,
    1229,  1230,  1231,   110,   113,   140,   165,   174, -1136, -1136,
   -1136,   390,  1471, -1136,   287,   542,   157,   162,   558, -1136,
   -1136, -1136,  -272, -1136, -1136,   251, -1136, -1136, -1136, -1136,
     459, -1136,   139,   217,   836,    31,   252,   256,   307,   284,
     304,   306,   309,    12,   191,   310,   220,   315,   225,   241,
     242,   247,    41,    90,   454,   551,   588, -1136,   500, -1136,
     629, -1136,   633, -1136,  -253, -1136,  -253, -1136,  -253, -1136,
    -253, -1136,   649, -1136,   670, -1136,   684, -1136,   694, -1136,
     726, -1136,   729, -1136,   730, -1136,   738, -1136,   760, -1136,
     779, -1136,   826, -1136,   837, -1136,  1199, -1136,  1200, -1136,
    1201, -1136,  1202, -1136,  1204, -1136,  1205, -1136,  1206, -1136,
    1207, -1136,  1208, -1136,  1209, -1136,  1212, -1136,  1213, -1136,
    1216, -1136,  1217, -1136,  1220,   318,   590,   515,   598,   610,
     614,   646,   647,   659,   660,   321,   324,   325,   326,   327,
     329,   330,   662,   663,   258,   259,   666, -1136, -1136, -1136,
     264, -1136, -1136,   539, -1136,   266, -1136,   667,   668,   194,
     205,   235,   236,   239,   669,   671,   672,   673,   359,   430,
     455,   240,   674,   675,   677,   678,    26,   679,   680, -1136,
    1221, -1136,  1222, -1136,  1223, -1136,  1224,   682,   685,   687,
     689,   690,   691,   692,   693,   695,   696,   697,   698,   703,
     704,   706,   707,   712,   969,   717,   718,   722,   728,   268,
     269,   270,   731,   732,   734,    23,   735,   737,   740,   742,
     750,   751,   752,   753,   755,   758,   759,   761,   762,   767,
     768,   254,   302, -1136,  1232,   770,   771,   777,   780,   790,
     791,   792,   272,   793,   794,   795,   -20,  1233,  1234,   458,
     536,   796,   799,   811,   817, -1136, -1136, -1136, -1136,  1211,
     648, -1136, -1136, -1136,  1247, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136,  -256, -1136,    45,    24,  1198, -1136,    52,  1354,
   -1136,    61,  1355, -1136,    69,  1356, -1136,    39,  1214, -1136,
     -12,  1235, -1136, -1136, -1136, -1136,   686, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1236,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136,  1240, -1136, -1136, -1136, -1136,
    1051,  1365, -1136,  1390,  1393,  1116,  1434, -1136, -1136, -1136,
   -1136, -1136,  -228, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
    1403, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136,  1240, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1271,  1272,
    1445, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136,  -201,  1423,  -201, -1136,   459,
   -1136, 11401, -1136,   459, 11401, -1136,   459, 11401, -1136,   459,
   11401, -1136,  1417, -1136, -1136, -1136,  1458,  1411, 11401,    42,
   -1136,  1427,  1420,  1419,  1415,   332,  1004, -1136,  1051,   296,
     299,  1428,   273,   274,   275, -1136, -1136, -1136,  1418,    47,
      65,    73,    75,    77, 10340, 10675, 10760, -1136,    88,    92,
      94,  1421,    96,    98,   108,   109,   111,   117,   121,   125,
    1452,   127,   135,   138,   141,  1453,  1454,  1455,  1456,  1457,
   10845,   145,   146,   148,  1459,  1460,  1462,  1463,  6100, 10845,
     149,   151,   152,   154,   172, -1136, -1136, -1136, -1136,   173,
   -1136, -1136, -1136,    80,  3420, -1136, -1136, -1136, -1136,  1012,
   -1136, -1136, -1136, -1136, -1136,  1467,  1429,   176, -1136,  1430,
    1461,  3492,  1464,  3581,  1466,  3828,  1468,   199,  1478,  3917,
   -1136,  1465,  1481,  1051, -1136, -1136, -1136, -1136, -1136, -1136,
    1483,  1484, -1136, -1136, -1136, -1136, -1136,  1476, -1136, -1136,
   -1136, -1136, -1136, -1136,  1473, -1136,   123, -1136,    46, -1136,
     144, -1136,   150, -1136,   166,   852, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136,   913, -1136,   913,
   -1136,   879, -1136, -1136,  1236, -1136, -1136,  6187,  6274,  6611,
    1491,  1492, -1136,  5252, 11334, -1136,   859, -1136,   655, -1136,
     870, -1136, -1136, -1136,  1012, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136,  6698,  1106,  5589,  1106,  5676,  1106, -1136,   229,
   -1136,   276, -1136,  6785,  1501, -1136,   277, -1136,   278, -1136,
     279, -1136,   280, -1136,   818, -1136,   819, -1136,  1495, -1136,
     201,  1496, -1136,   282, -1136,   285, -1136,   286, -1136,   288,
    1505,  1516,  1518,   161,   855,  7122, 10273, -1136,   189, -1136,
     821, -1136,    68,  1519,  1520,  1522,  1531, -1136,  1007, 10273,
   -1136,   289, -1136,   290, -1136,   699, -1136,   763, -1136,   841,
   -1136,  1535, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1545, -1136,  1533,
   -1136, 10845, -1136, -1136,    11, -1136,  1536, -1136,  1544, -1136,
    1557, -1136,  1558, -1136,  1635,  1636,   -12, -1136, 11401,  1469,
   -1136,  -233,  1573,  -127, 11401,  1564,  -165, -1136,   391, -1136,
     471,   918,  1565,   491,   501,   506,   922,  1574,   533,   705,
     804,   934,  1585,   812,   815,   875,  1013,  1587,   891,   919,
     938,  1014, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  7209,
    5066,  5159, -1136,  1210,  1597, -1136, -1136, -1136, -1136, -1136,
   -1136,  7296,  7633,  1589, -1136,  1634,  1643,  1644,  1648,  1060,
    1606,  1604,  3986, -1136,  7720, -1136, -1136, -1136, -1136, -1136,
    7807,  8144, -1136,  2672,  1611, -1136, -1136,  8231,  8318,  8655,
    8742, 10845, 10845, 10845, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136,  8829,  9166,  9253,  9340,  9677,
    9764,  9851, -1136, -1136,  1628,  1631,  1630,  1632,  1633,  1654,
      85,  1472,  1656,  1657,  1658,  1660,  1669,  1670,  1674,  1675,
    1676,  1684,  1697,  1698,  1699, -1136,  1700, -1136,  1701, -1136,
    1702,  1703,  1712,  1723,  1725,  1726,  1727,  1729, -1136, -1136,
   -1136,  1738,  1739, -1136,  1743,  1744, 11401,  1921, -1136,  1745,
    1753,  1754,  1755,  1756,  1627,  1750,  1758, -1136, -1136, -1136,
   -1136,    64, -1136,  1759,  1645,  1760,  1761,  1762,  1763,  1764,
    1765,  1766,  1767, 10845,  1800,  1787,  1106,   952, -1136,  1012,
   -1136,  1795, -1136, 11401, 11401, 11401, 11401,  1801,  1802,  1839,
    4058,  1811, -1136, -1136,  1799,  1803,  4164, -1136,   644, -1136,
    1812, -1136,  1814, -1136,   107,   206,  1817, -1136, -1136,   727,
   -1136,  1823, -1136,  1824, -1136,  1825, -1136, -1136,   741, -1136,
    1826, -1136,  1828, -1136,  1829, -1136, -1136,   743, -1136,  1830,
   -1136,  1832, -1136,  1833, -1136, -1136,   747, -1136,  1834, -1136,
    1835, -1136,  1836, -1136, -1136,  1879,  1123, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136,  1123, -1136, -1136,  1123,
   -1136, -1136, -1136,  1796, -1136,  1840,  1831,  2122,  1860,  2352,
   -1136, -1136, -1136, -1136, -1136, -1136,  1948,  1123, -1136,  1123,
   -1136,   964, -1136,  2017,  1240,  1810,  1849, -1136,  -174,  1123,
    -284, -1136,  2889, -1136,  2910, -1136,  3019, -1136,  2832,  3353,
    3399,  1193, -1136,   -21, -1136,   -21, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136,  1123, -1136,   964, -1136,  1837, -1136, -1136,
    1841, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136,  4394, 11265, -1136, -1136, -1136, -1136, -1136,   575,  1051,
   -1136,  1858,  5763,  1822, -1136, -1136,   701, -1136, 11180, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1106,  1048, -1136,
   -1136, -1136,  -201, -1136, -1136,   257,  4500,  4569,  4641,  4730,
   -1136, -1136,  -212, -1136,  1842, -1136, -1136, -1136,  1862,  1863,
    1864,  1865, -1136, -1136, -1136, -1136,  1866,  1867,  1868,  1869,
    1871,  1872,  1873,  1876,  1882,  1883,  1884,  1885,  1887,  1888,
    1889,  1891,  1892,  1893,  1894,  1895,  1896,  -116,  1597, -1136,
   -1136, -1136, -1136,   182,  1897,  1898,  1899, -1136, -1136, -1136,
   -1136,  1890, -1136,  1922, 10188,  1923,  1106, 11401, -1136, -1136,
    1900,  2813, 10845, -1136,  1901,  1903,  1904, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1926,
    1927, -1136, -1136,  1240, -1136, -1136, -1136, -1136,  -233, 11401,
    1928,  1929,  2759,  2828, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136,  2905, 11401, 11401, -1136,  3015,  3245,  3351
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     436,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   435,    22,
      23,     0,     0,     4,     0,     0,     0,     0,     0,     8,
       9,     6,     0,   433,    10,     0,    15,     7,   434,   483,
       0,   484,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   105,     0,   107,
       0,   109,     0,   111,     0,   113,     0,   115,     0,   117,
       0,   119,     0,   121,     0,   123,     0,   125,     0,   127,
       0,   129,     0,   131,     0,   133,     0,   135,     0,   137,
       0,   139,     0,   143,     0,   141,     0,   145,     0,   147,
       0,   149,     0,   151,     0,   153,     0,   155,     0,   157,
       0,   159,     0,   161,     0,   163,     0,   165,     0,   167,
       0,   169,     0,   171,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   448,   447,   450,
       0,   449,   455,     0,   457,     0,   456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   260,
       0,   262,     0,   264,     0,   266,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   380,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    60,    66,    65,    59,    61,
      63,    68,    71,    67,    69,   500,   499,   502,   501,   504,
     503,     1,     5,     3,     0,     0,     0,    12,     0,     0,
      14,     0,     0,    17,     0,     0,    19,     0,     0,    21,
       0,     0,   481,   466,   467,   468,     0,   424,   423,   422,
     421,   426,    31,    32,    33,    34,    35,   425,   428,     0,
      57,   427,   430,   429,   432,   431,    73,    72,    75,    74,
      77,    76,    79,    78,    81,    80,    83,    82,    85,    84,
      87,    86,    89,    88,    91,    90,    93,    92,    95,    94,
      97,    96,    99,    98,   336,   582,   580,   581,    25,   463,
       0,     0,    30,    50,     0,    55,   334,    24,   460,   464,
     461,   583,    26,   338,   337,   340,   339,   101,   100,   103,
     102,   104,   106,   108,   110,   112,   114,   116,   118,   120,
     122,   124,   126,   128,   130,   132,   134,   136,   138,   142,
     140,   144,   146,   148,   150,   152,   154,   156,   158,   160,
     162,   164,   166,   168,   170,   173,   172,   180,   174,   175,
     182,   181,   184,   183,   186,   185,   188,   187,   190,   189,
     192,   191,   194,   193,   196,   195,   198,   197,   200,   199,
     202,   201,   204,   203,   206,   205,   208,   207,   210,   209,
     327,   326,   329,   328,   331,   330,   333,   332,   452,   451,
       0,   459,   458,   177,   176,   179,   178,   215,   214,   213,
     218,   217,   216,   221,   220,   219,   224,   223,   222,   227,
     226,   225,   229,   228,   231,   230,   233,   232,   235,   234,
     237,   236,   239,   238,   241,   240,   244,   242,   243,   246,
     245,   248,   247,   250,   249,   252,     0,   251,   254,   253,
     256,   255,   258,   257,   259,   261,   263,   265,   268,   267,
     270,   269,   272,   271,   274,   273,   276,   275,   278,   277,
     280,   279,   282,   281,   284,   283,   286,   285,   288,   287,
     290,   289,   292,   291,   294,   293,   296,   295,   298,   297,
     300,   299,   305,   301,   302,   303,   304,   317,   316,   319,
     318,   307,   306,   309,   308,   311,   310,   313,   312,   315,
     314,   321,   320,   323,   322,   325,   324,   342,   341,   344,
     343,   346,   345,   348,   347,   350,   349,   352,   351,   354,
     353,   356,   355,   358,   357,   360,   359,   362,   361,   364,
     363,   366,   365,   368,   367,   370,   369,   372,   371,   375,
     373,   374,   378,   376,   377,   379,   382,   381,   384,   383,
     386,   385,   388,   387,   390,   389,   392,   391,   394,   393,
     212,   211,   396,   395,   398,   397,   400,   399,     0,     0,
       0,   407,   408,   412,   411,   410,   409,   414,   413,   416,
     415,   418,   417,   420,   419,     0,     0,     0,   473,     0,
     474,     0,   478,     0,     0,   491,     0,     0,   495,     0,
       0,   498,     0,   438,   439,   437,     0,     0,     0,     0,
      58,     0,    27,     0,     0,     0,     0,    56,     0,     0,
       0,     0,     0,     0,     0,    62,    64,    70,     0,     0,
       0,     0,     0,     0,   885,   882,   886,   889,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   838,   840,   842,   845,     0,
       0,     0,     0,     0,   859,   861,   863,   865,     0,     0,
       0,     0,     0,     0,     0,   715,   716,   717,   642,     0,
     654,   655,   600,     0,     0,   592,   595,   596,   597,     0,
     646,   647,   657,   658,   659,     0,     0,     0,   588,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     487,     0,     0,     0,    29,   465,    54,    44,    43,    51,
      52,     0,   587,   582,   585,   586,   584,     0,   402,   401,
     404,   403,   406,   405,     0,   728,     0,   750,     0,   761,
       0,   772,     0,   739,     0,     0,   526,   527,   528,   539,
     532,   540,   533,   538,   530,   537,   529,     0,   531,     0,
     534,     0,   535,   628,   674,   672,   673,     0,     0,     0,
       0,     0,   661,     0,     0,   660,     0,   536,     0,   541,
       0,   667,   666,   665,     0,   648,   650,   649,   662,   663,
     664,   675,     0,   884,     0,   881,     0,   888,   776,     0,
     793,     0,   797,     0,     0,   801,     0,   820,     0,   823,
       0,   804,     0,   810,     0,   807,     0,   813,     0,   816,
       0,     0,   829,     0,   832,     0,   826,     0,   835,     0,
       0,     0,     0,     0,     0,     0,     0,   851,     0,   854,
       0,   857,     0,     0,     0,     0,     0,   620,     0,     0,
     868,     0,   871,     0,   780,     0,   783,     0,   786,     0,
     875,     0,   601,   594,   593,   471,   591,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,     0,   640,   643,
     656,     0,   599,   791,     0,   598,     0,   476,     0,   489,
       0,   493,     0,   444,   440,   441,     0,   482,     0,     0,
      28,     0,     0,     0,     0,     0,     0,   575,     0,   718,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   545,   505,   506,   514,   507,   508,   513,     0,
       0,     0,   570,     0,     0,   713,   696,   698,   677,   699,
     678,     0,     0,     0,   883,   648,   649,   663,   664,     0,
       0,     0,     0,   549,     0,   554,   509,   510,   511,   512,
       0,     0,   566,     0,   643,   697,   676,     0,     0,     0,
       0,     0,     0,     0,   515,   516,   521,   517,   518,   519,
     520,   522,   523,   524,   525,     0,     0,     0,     0,     0,
       0,     0,   880,   887,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   812,     0,   815,     0,   818,
       0,     0,     0,     0,     0,     0,     0,     0,   837,   839,
     841,     0,     0,   844,     0,     0,     0,   602,   589,     0,
       0,     0,     0,     0,    45,     0,     0,   858,   860,   862,
     864,     0,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   876,     0,     0,   714,     0,   653,     0,
     651,     0,   652,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,   335,     0,     0,     0,   729,     0,   727,
       0,   720,     0,   721,     0,     0,     0,   719,   751,     0,
     749,     0,   742,     0,   743,     0,   741,   762,     0,   760,
       0,   753,     0,   754,     0,   752,   773,     0,   771,     0,
     764,     0,   765,     0,   763,   740,     0,   738,     0,   731,
       0,   732,     0,   730,   544,     0,   542,   560,    36,    37,
      38,    39,    40,    41,    42,   558,   559,   557,   555,   556,
     569,   567,   568,   623,   627,   629,     0,     0,     0,     0,
     671,   693,   670,   669,   668,   548,     0,   546,   553,   551,
     552,   550,   565,     0,    57,     0,   573,   561,   563,   562,
       0,   710,   692,   709,   691,   705,   684,   706,   685,   686,
     687,   688,   700,   679,   701,   680,   702,   681,   703,   682,
     704,   683,   708,   690,   707,   689,   777,     0,   774,   794,
       0,   798,   796,   795,   799,   802,   800,   821,   819,   824,
     822,   805,   803,   811,   809,   808,   806,   817,   814,   830,
     828,   833,   831,   827,   825,   836,   834,   846,   843,   848,
     847,     0,     0,   850,   849,   853,   852,   856,     0,     0,
     855,     0,     0,     0,   619,   617,     0,   869,     0,   872,
     870,   778,   779,   781,   782,   784,   785,   879,     0,   878,
     641,   645,     0,   790,   643,     0,     0,     0,     0,     0,
     442,   443,     0,   486,     0,   453,   454,   472,     0,     0,
       0,     0,   579,   577,   578,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   711,
     694,   712,   695,     0,     0,     0,     0,   590,   603,    49,
      46,    47,   621,     0,     0,     0,   604,   610,   618,   616,
      57,     0,     0,   874,     0,     0,     0,   477,   490,   494,
     497,   445,   446,   462,   725,   726,   723,   724,   722,   747,
     748,   745,   746,   744,   758,   759,   756,   757,   755,   769,
     770,   767,   768,   766,   736,   737,   734,   735,   733,     0,
       0,   626,   574,   572,   571,   644,   775,   792,     0,   613,
       0,     0,     0,     0,   866,   867,   877,   789,   788,   787,
     625,   624,    48,     0,   614,   608,   615,     0,     0,     0
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1136, -1136, -1136,  1976, -1136, -1136, -1136, -1136, -1136,  -393,
    1287,  1314,  -210,   990, -1135, -1136, -1136,  -194,  -215, -1136,
    1443, -1136,  -183, -1136,  1442, -1136, -1136, -1136,  1137, -1136,
   -1136,  -961,  1917,  1746,  1919,  -616, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136,  -981, -1136,  -933, -1136, -1136,  1097, -1136, -1136, -1136,
    1103, -1136, -1136,  -907,  -656, -1136,  -103, -1082,  -785,  -677,
   -1136,   700,   783, -1136, -1136, -1136,   708, -1136, -1136, -1136,
   -1136,   973,  -990,  -394,  -826, -1136,  -752, -1136, -1136, -1136,
    -609,  -780, -1136, -1136, -1136, -1136,  -110,   160, -1136, -1136,
   -1136, -1136,   710, -1136
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   532,
     853,   533,   534,  1395,   959,  1296,   535,   536,  1015,   199,
     438,   439,   440,   200,   443,   444,   201,   202,   846,   203,
     204,   537,   538,   539,   540,   476,   456,   457,   459,   460,
     205,   206,   848,   951,   462,   463,   465,   466,   468,   469,
     207,  1178,  1211,  1179,  1240,  1241,  1016,  1017,  1018,  1019,
    1020,  1021,  1427,  1151,   541,   542,  1022,  1287,   924,   925,
     926,  1585,  1505,  1506,   927,   928,  1404,  1405,  1023,  1184,
    1117,  1118,  1119,  1024,  1025,  1026,  1027,   932,  1028,  1321,
    1029,  1030,  1121,   935,  1031,  1032,  1199,   936,   937,   938,
    1101,  1518,  1519,   939
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     491,   442,   748,   497,   487,   930,  1332,  1302,   930,   209,
     211,   930,  1317,   506,   930,  1150,  1180,  1155,  1181,  1160,
    1183,  1165,   930,  1170,   747,   830,   237,   678,   489,   554,
     329,   555,   488,   556,  1214,   557,   208,  1210,   332,   544,
     841,   490,   524,   950,   239,   843,   828,  1152,   975,   941,
     470,   934,   943,   832,   934,   945,  1521,   934,   212,   489,
     934,   327,   835,   949,   426,  1501,   977,   471,   934,  1293,
     838,  1156,   490,  1161,   979,  1166,   981,  1171,   983,   931,
     957,  1102,   931,  1204,   859,   931,  1100,  1213,   931,  1038,
     586,   543,   958,  1040,   860,  1042,   931,  1045,   930,  1047,
     605,   607,   609,   611,   613,   615,   617,  1153,  1542,  1049,
    1051,   435,  1053,  1601,   441,   930,  1602,   930,  1055,   930,
    1502,  1503,  1057,   930,  1145,   436,  1059,   437,  1062,   482,
     483,   484,   485,   661,   663,   665,  1064,   852,  1344,  1066,
     477,   445,  1068,   213,   934,  1157,  1077,  1079,  1345,  1081,
    1090,  1162,  1092,  1094,   214,  1096,   482,   483,   484,   485,
     215,   934,  1281,   934,   216,   934,   447,  1167,  1338,   934,
    1339,   217,   931,  1098,  1100,   449,   461,  1123,   482,   483,
     484,   485,   464,  1632,  1146,   489,   218,  1195,   930,   931,
    1289,   931,   508,   931,   219,   637,   489,   931,   490,   220,
    1133,  1334,  1266,   964,   966,  1158,   640,  1544,  1195,   490,
    1195,  1163,  1629,   868,   814,   816,   221,   940,   479,   222,
     942,   512,   933,   944,   223,   933,   516,  1168,   933,  1202,
    1244,   933,   334,  1198,   934,   224,   643,   646,   225,   933,
     649,   666,   518,   520,   808,   809,   810,  1106,   522,  1195,
     930,   226,  1426,   492,  1198,   779,  1198,   494,  1595,   622,
     624,  1196,   931,   930,  1106,   628,  1106,   631,  1106,   735,
     737,   739,  1106,   800,   968,   970,   972,  1247,  1253,  1255,
    1257,  1259,  1196,  1270,  1196,   498,  1272,  1274,   918,  1276,
    1303,  1305,  1237,  1238,  1239,  1198,   934,   962,  1320,   241,
     965,   454,   455,   782,   243,   500,  1428,   502,   496,   934,
     504,   510,   930,   844,   845,   933,   514,   238,   930,   585,
     227,   330,   604,  1196,   931,   606,   608,   610,   612,  1524,
     614,   616,   933,   956,   933,   240,   933,   931,   507,  1318,
     933,   857,   921,   489,  1322,  -479,  -480,   210,   525,   526,
     527,   528,   529,  1330,   486,   529,   490,   331,   934,  1336,
     660,  -470,   531,  1580,   934,   531,   525,   526,   527,   528,
     529,   676,  1147,   333,  1154,   529,   930,   530,  -496,  -485,
     531,   486,  -469,   976,   829,   531,   931,   228,   328,  -475,
     451,   833,   931,   525,   526,   527,   528,   529,  -488,  1288,
     836,   978,  1504,   486,  1197,   933,  -492,   531,   839,   980,
    1578,   982,  1288,   984,  1103,   525,   526,   527,   528,   529,
    1462,  -873,   934,   229,  1039,  1197,   530,  1197,  1041,   531,
    1043,   662,  1046,  1543,  1048,  1183,   436,   929,   437,   436,
     929,   437,  1183,   929,  1050,  1052,   929,  1054,   676,  1147,
     931,  1148,   529,  1056,   929,   545,   664,  1058,  1149,   813,
     930,  1060,   531,  1063,   478,   961,  1197,   933,   446,   676,
    1147,  1065,  1159,   529,  1067,   676,  1147,  1069,  1164,   529,
     933,  1078,  1080,   531,  1082,  1091,  1282,  1093,  1095,   531,
    1097,   676,  1147,   448,  1169,   529,  1283,   930,   930,   930,
     930,  1491,   450,  1652,   930,   531,   934,  1633,  1099,  -873,
     930,   529,  1124,   489,   525,   526,   527,   528,   529,   509,
     638,   531,   639,   335,  1134,  1106,   490,  1135,   531,   933,
     929,   641,  1545,   642,   931,   933,  1267,   815,  1526,  1527,
    1528,  1529,   480,   934,   934,   934,   934,   929,   513,   929,
     934,   929,   547,   517,  1245,   929,   934,  1246,   458,   336,
     852,   644,   647,   645,   648,   650,   667,   651,   668,   519,
     521,   931,   931,   931,   931,   523,  1579,   493,   931,   467,
     780,   495,   781,   436,   931,   437,   623,   625,   472,   549,
     242,   587,   629,   933,   632,   244,   736,   738,   740,   590,
     801,   969,   971,   973,  1248,  1254,  1256,  1258,  1260,   499,
    1271,   592,  1634,  1273,  1275,   594,  1277,  1304,  1306,   489,
     929,   963,   526,   527,   963,   526,   527,   783,   784,   501,
     489,   503,   490,   489,   505,   511,   489,   489,   489,   489,
     515,   489,   489,   490,   442,   957,   490,   596,   598,   490,
     490,   490,   490,  1106,   490,   490,  1205,   958,   245,  1106,
     600,   602,   247,   618,   620,   930,   930,   626,   633,   635,
     652,   489,   654,   656,   658,   669,   671,   933,   673,   675,
     680,   682,   929,   688,   490,  1290,   690,   230,   692,  1294,
     694,   696,   698,   700,   702,   929,   704,   706,   708,   710,
     930,   930,   930,   930,   712,   714,  1538,   716,   718,   231,
     249,   934,   934,   720,   933,   933,   933,   933,   727,   729,
     232,   933,   251,   731,  1340,   233,  1341,   933,   923,   733,
    1319,   923,   741,   743,   923,   745,   749,   923,   751,   931,
     931,   753,   489,   755,   929,   923,   934,   934,   934,   934,
     929,   757,   759,   761,   763,   490,   765,  1502,  1503,   767,
     769,   930,   771,   773,  1033,  1035,  1037,   489,   775,   777,
     489,   786,   788,   253,   931,   931,   931,   931,   790,   546,
     490,   792,   255,   490,   473,   474,   234,   475,   257,  1547,
    1076,   794,   796,   798,   802,   804,   806,   817,  1088,  1089,
     819,   235,  1643,  1552,  1342,  1557,  1343,   934,   929,  1562,
     236,   305,   821,   930,  1106,  1288,   930,   930,   823,  1261,
    1263,   923,  1291,   259,  1349,   551,  1350,   930,   930,   930,
     306,   930,   930,   930,  1351,   931,  1352,   481,   923,  1353,
     923,  1354,   923,   589,   307,  1268,   923,   261,   489,  1106,
    1106,  1106,  1106,  1172,  1653,   308,  1284,  1657,   309,   934,
    1203,   490,   934,   934,  1285,   263,  1358,   630,  1359,  1658,
    1659,  1212,  1295,   934,   934,   934,   548,   934,   934,   934,
    1182,   310,   933,   933,   311,   312,   265,   931,   957,   313,
     931,   931,   929,   314,   315,   267,   269,  1186,  1188,  1190,
     958,   931,   931,   931,   271,   931,   931,   931,   273,   275,
     277,   923,  1308,   550,  1310,   588,  1312,   933,   933,   933,
     933,   279,  1216,   591,   482,   483,   484,   485,  1335,   929,
     929,   929,   929,  1251,   281,   593,   929,   283,   285,   595,
     287,   289,   929,   482,   483,   484,   485,   291,   293,   246,
     295,   297,   299,   248,   552,  1173,  1174,   316,   553,   301,
    1176,  1177,  1206,  1207,  1208,  1209,  1106,   303,   317,  1539,
     722,   597,   599,   923,   558,   359,  1106,   361,   933,   363,
    1106,  1106,  1106,   365,   601,   603,   923,   619,   621,   413,
     826,   627,   634,   636,   653,   559,   655,   657,   659,   670,
     672,   250,   674,   676,   681,   683,   318,   689,   319,   560,
     691,  1316,   693,   252,   695,   697,   699,   701,   703,   561,
     705,   707,   709,   711,  1307,   436,   849,   437,   713,   715,
     933,   717,   719,   933,   933,   923,   320,   721,  1360,  1588,
    1361,   923,   728,   730,   933,   933,   933,   732,   933,   933,
     933,   562,  1548,   734,   563,   564,   742,   744,   321,   746,
     750,   322,   752,   565,   254,   754,  1553,   756,  1558,  1386,
    1396,  1399,  1563,   256,   323,   758,   760,   762,   764,   258,
     766,  1407,  1409,   768,   770,   566,   772,   774,  1309,   436,
     324,   437,   776,   778,  1417,   787,   789,   929,   929,   923,
    1419,  1421,   791,  1429,   567,   793,  1581,  1432,  1434,  1436,
    1438,  1439,  1440,  1441,   260,   795,   797,   799,   803,   805,
     807,   818,   325,   326,   820,  1443,  1445,  1447,  1449,  1451,
    1453,  1455,   929,   929,   929,   929,   822,  1362,   262,  1363,
     337,   338,   824,  1262,  1264,  1367,  1292,  1368,  1369,   486,
    1370,   568,  1173,  1174,  1175,   339,   264,  1176,  1177,  1173,
    1174,  1175,   569,   340,  1176,  1177,  1311,   436,   486,   437,
    1173,  1174,  1175,  1200,   341,  1176,  1177,   266,   342,  1173,
    1174,   343,   344,   923,  1176,  1177,   268,   270,   345,   723,
     724,   725,   726,   929,  1200,   272,  1200,   346,   347,   274,
     276,   278,   348,  1517,   482,   483,   484,   485,  1371,   349,
    1372,  1400,   280,  1173,  1174,  1574,   350,   351,  1176,  1177,
     923,   923,   923,   923,  1376,   282,  1377,   923,   284,   286,
    1344,   288,   290,   923,  1344,  1200,   352,   353,   292,   294,
    1345,   296,   298,   300,  1345,   929,  1344,   354,   929,   929,
     302,  1346,  1378,  1347,  1379,  1355,  1345,  1356,   304,   929,
     929,   929,   355,   929,   929,   929,   360,  1364,   362,  1365,
     364,  1380,   356,  1381,   366,  1235,  1236,  1237,  1238,  1239,
     414,   986,   987,   988,   989,  1522,   991,  1523,   993,   357,
     995,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,
    1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,
    1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,
    1237,  1238,  1239,   358,   367,  1344,  1344,   368,   369,   525,
     526,   527,   528,   529,   370,  1345,  1345,   371,  1116,  1594,
     530,   372,  1596,   531,  1301,   373,  1373,  1382,  1374,  1383,
     374,   375,  1630,  1217,  1218,  1219,  1220,  1221,  1222,  1223,
    1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,
    1234,  1235,  1236,  1237,  1238,  1239,   525,   526,   527,   528,
     529,  1592,   376,  1593,   377,   378,   379,   380,   923,   923,
     531,   381,  1586,   382,   383,  1411,   384,   385,  1591,  1217,
    1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,  1227,
    1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,
    1238,  1239,   386,   923,   923,   923,   923,   387,   388,   486,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,   389,
     390,   525,   526,   527,   528,   529,   391,   392,   393,   394,
     395,   396,   530,   397,   398,   531,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     415,    -2,   452,   416,  1586,   417,   418,   419,   420,   421,
     422,   423,  1517,   424,   923,   -11,   -11,   -13,     2,     3,
     -16,   -18,   -20,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     4,
     425,   427,     5,     6,     7,     8,     9,   428,   429,   430,
     431,   432,   433,   434,   570,   571,   572,   573,    10,   574,
     575,   576,   577,   578,   579,   831,   923,   580,   581,   923,
     923,   582,   583,   858,   825,   584,   684,   685,   686,   687,
     923,   923,   923,   842,   923,   923,   923,   785,   811,   812,
     847,   850,   851,   862,   863,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
     827,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   834,   837,   840,   529,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   855,   173,   174,   856,   861,   864,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   866,   946,
     947,   948,   952,   953,   954,   955,   967,  1044,   974,  1120,
     185,   186,   187,  1122,  1125,  1217,  1218,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1061,  1070,
    1071,  1072,  1073,  1074,  1331,  1083,  1084,   188,  1085,  1086,
    1136,  1126,  1138,  1139,  1128,   189,  1130,  1463,  1132,  1143,
    1144,  1100,   190,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  1141,  1142,  1191,  1192,  1252,
    1265,  1269,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    1278,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  1279,  -575,  1280,  1297,  1298,  -575,  1299,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  -575,  1300,  1314,  -575,  -575,
    -575,  1313,  1315,  1323,  -575,  -575,  -575,  -575,  -575,  -575,
    1100,  1324,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  1325,  1326,  1327,  1328,  1333,  1337,
    1348,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  1357,
    -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    1366,  -543,  1375,  1403,  1410,  -543,  -646,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  -543,  -647,  -658,  -543,  -543,  -543,
    -659,  1412,  1413,  -543,  -543,  -543,  -543,  -543,  -543,  1182,
    1430,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  1456,  1457,  1458,  1460,  1459,  1492,  1498,
    -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  1508,  -547,
    -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  1461,
    -547,  1464,  1465,  1466,  -547,  1467,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  -547,  1468,  1469,  -547,  -547,  -547,  1470,
    1471,  1472,  -547,  -547,  -547,  -547,  -547,  -547,  1182,  1473,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  1474,  1475,  1476,  1477,  1478,  1479,  1480,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  1481,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  1482,  -564,
    1483,  1484,  1485,  -564,  1486,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,  1487,  1488,  -564,  -564,  -564,  1489,  1490,
    1493,  -564,  -564,  -564,  -564,  -564,  -564,  -575,  1494,  1495,
    1496,  1497,  1499,  1500,  1507,  1509,  1510,  1511,  1512,  1513,
    1514,  1515,  1516,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  -575,  1116,  1521,  1525,  1530,
    1531,  1532,  -575,  1534,  1535,  1567,  -575,  1540,  1536,  1541,
    -575,  -575,  1546,  -575,  -575,  -575,  -873,  -575,  1549,  1550,
    1551,  1554,  -575,  1555,  1556,  1559,  -543,  1560,  1561,  1564,
    1565,  1566,  1568,  1573,  1587,  1575,  1569,  1603,   453,  1576,
     960,  1398,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  -543,  1571,  1582,  1604,  1605,  1606,
    1607,  1608,  1609,  1610,  1611,  -543,  1612,  1613,  1614,  -543,
    -543,  1615,  -543,  -543,  -543,  -873,  -543,  1616,  1617,  1618,
    1619,  -543,  1620,  1621,  1622,  -547,  1623,  1624,  1625,  1626,
    1627,  1628,  1638,  1636,  1637,  1644,  1647,  1635,  1648,  1649,
    1140,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  -547,  1639,  1642,  1650,  1651,   865,   867,
    1654,  1655,   677,  1329,  -547,   679,  1631,   854,  -547,  -547,
    1401,  -547,  -547,  -547,  1641,  -547,  1402,  1520,     0,  1589,
    -547,     0,     0,     0,  -564,     0,     0,     0,     0,     0,
       0,     0,  1646,     0,     0,     0,     0,     0,     0,     0,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -564,     0,     0,     0,  -564,  -564,     1,
    -564,  -564,  -564,     0,  -564,     0,     0,     0,     0,  -564,
       0,     0,   -11,   -11,   -13,     2,     3,   -16,   -18,   -20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     5,
       6,     7,     8,     9,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1217,  1218,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,     0,
       0,     0,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,  1570,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,     0,     0,
       0,     0,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,     0,
     173,   174,     0,     0,     0,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   185,   186,   187,
       0,     0,     0,     0,     0,  1217,  1218,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,     0,
       0,     0,     0,  1422,   188,   869,   870,   871,   872,   873,
       0,     0,   189,     0,   878,   879,   880,  1572,     0,   190,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1423,  1002,
    1656,     0,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,  -607,  -607,   909,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,  1104,
       0,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,  -609,  -609,   909,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,     0,     0,
       0,     0,     0,     0,     0,     0,  1104,     0,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,   918,
    1003,   900,     0,   901,   902,   903,   904,   905,   906,   907,
     908,  -611,  -611,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,  1424,  1425,     0,
    1012,   529,   920,   921,     0,     0,     0,     0,  1075,  1014,
       0,   531,     0,     0,     0,     0,  1104,     0,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,   918,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,   900,     0,   901,   902,   903,   904,   905,   906,   907,
     908,  -605,  -605,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   919,     0,     0,     0,   920,
     921,     0,     0,   922,     0,     0,     0,  -607,     0,     0,
       0,     0,     0,     0,     0,   918,  1217,  1218,  1219,  1220,
    1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1645,     0,
       0,     0,     0,     0,   919,     0,     0,     0,   920,   921,
       0,     0,   922,     0,     0,     0,  -609,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1218,  1219,  1220,  1221,  1222,  1223,  1224,
    1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,  1219,  1220,  1221,  1222,  1223,
    1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,
    1234,  1235,  1236,  1237,  1238,  1239,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,     0,  -611,     0,     0,  1104,     0,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,   900,   918,   901,   902,   903,   904,   905,   906,   907,
     908,  -612,  -612,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,  1220,  1221,  1222,  1223,  1224,
    1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,  1104,  -605,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,  -606,  -606,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,  1104,     0,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,   909,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
       0,     0,     0,  1104,     0,   869,   870,   871,   872,   873,
     874,   875,   876,   877,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,   918,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,     0,     0,
     909,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,  1104,  -612,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,   918,   901,
     902,   903,   904,   905,   906,   907,   908,     0,     0,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922,     0,     0,     0,  -606,
       0,     0,     0,     0,     0,     0,     0,   918,  1223,  1224,
    1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,     0,     0,
     920,   921,     0,     0,   922,     0,     0,     0,  1105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   919,     0,
       0,     0,   920,   921,     0,     0,   922,     0,     0,  1104,
    1127,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,   918,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,     0,     0,   909,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922,     0,     0,  1104,  1129,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,   900,     0,   901,   902,   903,   904,   905,
     906,   907,   908,     0,     0,   909,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,  1104,     0,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,   900,     0,   901,   902,   903,   904,   905,   906,
     907,   908,     0,     0,   909,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,     0,     0,     0,  1104,
       0,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,   900,   918,   901,   902,   903,   904,
     905,   906,   907,   908,     0,     0,   909,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   919,     0,     0,     0,   920,   921,
       0,     0,   922,     0,     0,  1104,  1131,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,   918,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
       0,     0,   909,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   919,     0,     0,     0,   920,   921,     0,
       0,   922,     0,     0,     0,  1137,     0,     0,     0,     0,
       0,     0,     0,   918,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   919,     0,     0,     0,   920,   921,     0,     0,
     922,     0,     0,     0,  1414,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   919,     0,     0,     0,   920,   921,
       0,     0,   922,     0,     0,  1104,  1533,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
     900,   918,   901,   902,   903,   904,   905,   906,   907,   908,
       0,     0,   909,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     919,     0,     0,     0,   920,   921,     0,     0,   922,     0,
       0,  1104,  1537,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,   909,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
    1104,     0,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,     0,     0,   909,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,     0,
       0,     0,  1104,     0,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,   918,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,     0,     0,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     919,     0,     0,     0,   920,   921,     0,     0,   922,     0,
       0,  1104,  1577,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,   900,   918,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,   909,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,     0,     0,
     920,   921,     0,     0,   922,     0,     0,     0,  1597,     0,
       0,     0,     0,     0,     0,     0,   918,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   919,     0,     0,     0,   920,
     921,     0,     0,   922,     0,     0,     0,  1598,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922,     0,     0,     0,  1599,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,     0,     0,
     920,   921,     0,     0,   922,     0,     0,  1387,  1600,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1388,  1389,  1390,  1391,  1392,  1393,
    1397,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1388,  1389,  1390,
    1391,  1392,  1393,  1193,     0,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1394,
       0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,     0,  1075,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,  1394,     0,     0,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,   920,
     921,     0,     0,     0,     0,  1075,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,
    1012,     0,   920,   921,     0,     0,     0,  1194,  1075,  1014,
    1193,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1193,     0,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1583,     0,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,     0,
       0,   901,   902,   903,   904,   905,   906,   907,     0,     0,
       0,     0,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,   920,
     921,     0,     0,     0,  1242,  1075,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,  1243,  1075,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1004,     0,  1584,     0,  1005,
       0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,
       0,  1012,     0,   920,   921,     0,     0,     0,     0,  1075,
    1014,  1087,     0,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1185,     0,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,     0,     0,   901,   902,   903,   904,   905,
     906,   907,     0,     0,     0,     0,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,   985,   986,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  1002,  1187,     0,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
       0,     0,   901,   902,   903,   904,   905,   906,   907,     0,
       0,     0,     0,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   918,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1004,
       0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,
    1010,  1011,   490,   919,     0,  1012,     0,   920,   921,     0,
       0,     0,     0,  1075,  1014,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   918,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
    1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,
     919,     0,  1012,     0,   920,   921,     0,     0,     0,     0,
    1075,  1014,  1189,     0,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,     0,     0,   901,
     902,   903,   904,   905,   906,   907,     0,     0,     0,     0,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1215,
       0,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,     0,     0,   901,   902,   903,   904,
     905,   906,   907,     0,     0,     0,     0,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1249,     0,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,  1003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,  1005,     0,  1006,
    1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,
       0,   920,   921,     0,     0,     0,     0,  1075,  1014,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,
       0,  1010,  1011,   490,   919,     0,  1012,     0,   920,   921,
       0,     0,     0,     0,  1075,  1014,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,  1250,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1075,  1014,  1193,     0,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1384,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1406,     0,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,
    1012,     0,   920,   921,     0,     0,     0,     0,  1075,  1014,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,  1385,     0,  1012,     0,   920,
     921,     0,     0,     0,     0,  1075,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,     0,  1075,  1014,  1408,     0,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,     0,
       0,   901,   902,   903,   904,   905,   906,   907,     0,     0,
       0,     0,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,  1415,     0,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1416,  1002,  1418,     0,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,     0,     0,   901,   902,   903,   904,   905,
     906,   907,     0,     0,     0,     0,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,   985,   986,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1004,     0,     0,     0,  1005,
       0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,
       0,  1012,     0,   920,   921,     0,     0,     0,     0,  1075,
    1014,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   918,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1004,
       0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,
    1010,  1011,   490,   919,     0,  1012,     0,   920,   921,     0,
       0,     0,     0,  1075,  1014,  1420,     0,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
       0,     0,   901,   902,   903,   904,   905,   906,   907,     0,
       0,     0,     0,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1431,     0,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,     0,     0,   901,
     902,   903,   904,   905,   906,   907,     0,     0,     0,     0,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1433,
       0,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,     0,     0,   901,   902,   903,   904,
     905,   906,   907,     0,     0,     0,     0,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   918,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
    1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,
     919,     0,  1012,     0,   920,   921,     0,     0,     0,     0,
    1075,  1014,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,  1003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,  1005,     0,  1006,
    1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,
       0,   920,   921,     0,     0,     0,     0,  1075,  1014,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,
       0,  1010,  1011,   490,   919,     0,  1012,     0,   920,   921,
       0,     0,     0,     0,  1075,  1014,  1435,     0,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1437,     0,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1442,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,   919,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1075,  1014,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,
    1012,     0,   920,   921,     0,     0,     0,     0,  1075,  1014,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,   920,
     921,     0,     0,     0,     0,  1075,  1014,  1444,     0,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1446,     0,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,     0,
       0,   901,   902,   903,   904,   905,   906,   907,     0,     0,
       0,     0,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,  1448,     0,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,     0,  1075,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1004,     0,     0,     0,  1005,
       0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,
       0,  1012,     0,   920,   921,     0,     0,     0,     0,  1075,
    1014,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,  1450,     0,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,     0,     0,   901,   902,   903,   904,   905,
     906,   907,     0,     0,     0,     0,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,   985,   986,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  1002,  1452,     0,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
       0,     0,   901,   902,   903,   904,   905,   906,   907,     0,
       0,     0,     0,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1454,     0,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,     0,     0,   901,
     902,   903,   904,   905,   906,   907,     0,     0,     0,     0,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   918,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1004,
       0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,
    1010,  1011,   490,   919,     0,  1012,     0,   920,   921,     0,
       0,     0,     0,  1075,  1014,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   918,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
    1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,
     919,     0,  1012,     0,   920,   921,     0,     0,     0,     0,
    1075,  1014,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,  1003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,  1005,     0,  1006,
    1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,
       0,   920,   921,     0,     0,     0,     0,  1075,  1014,  1640,
       0,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,     0,     0,   901,   902,   903,   904,
     905,   906,   907,     0,     0,     0,     0,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,   900,
       0,   901,   902,   903,   904,   905,   906,   907,   908,     0,
       0,   909,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,
       0,  1010,  1011,   490,   919,     0,  1012,     0,   920,   921,
       0,     0,     0,     0,  1075,  1014,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1217,  1218,  1219,  1220,
    1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   919,
       0,     0,     0,   920,   921,     0,     0,   922,     0,     0,
    1286,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1013,  1014,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,   919,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1034,  1014,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1036,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,   919,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1075,  1014,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,   900,     0,   901,   902,   903,   904,   905,   906,   907,
     908,     0,     0,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,  1201,     0,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
       0,     0,   909,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   918,  1003,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,  1590,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,  1286,     0,     0,     0,     0,     0,     0,     0,
       0,   918,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     919,     0,     0,     0,   920,   921,     0,     0,   922,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922
};

static const yytype_int16 yycheck[] =
{
     215,   184,   395,   218,   214,   831,  1141,  1089,   834,     1,
       1,   837,     1,     1,   840,   976,   997,   978,   999,   980,
    1001,   982,   848,   984,     1,     1,     1,     1,   312,   244,
       1,   246,     1,   248,  1024,   250,   292,  1018,     1,   233,
       1,   325,     1,     1,     1,    57,     1,     1,     1,   834,
     322,   831,   837,     1,   834,   840,   340,   837,   292,   312,
     840,     1,     1,   848,   322,     1,     1,   339,   848,     1,
       1,   978,   325,   980,     1,   982,     1,   984,     1,   831,
     313,     1,   834,  1016,   312,   837,     1,  1020,   840,     1,
     305,     1,   325,     1,   322,     1,   848,     1,   924,     1,
     315,   316,   317,   318,   319,   320,   321,    61,     1,     1,
       1,     1,     1,   325,     1,   941,   328,   943,     1,   945,
      56,    57,     1,   949,     1,   326,     1,   328,     1,    88,
      89,    90,    91,   348,   349,   350,     1,   530,   312,     1,
       1,     1,     1,   292,   924,     1,     1,     1,   322,     1,
       1,     1,     1,     1,   292,     1,    88,    89,    90,    91,
     292,   941,     1,   943,   292,   945,     1,     1,   333,   949,
     335,   292,   924,     1,     1,     1,    19,     1,    88,    89,
      90,    91,    20,     1,    61,   312,   292,  1013,  1014,   941,
       1,   943,     1,   945,   292,     1,   312,   949,   325,   292,
       1,   328,     1,   859,   860,    61,     1,     1,  1034,   325,
    1036,    61,   328,   829,   429,   430,   292,   833,     1,   292,
     836,     1,   831,   839,   292,   834,     1,    61,   837,  1014,
       1,   840,     1,  1013,  1014,   292,     1,     1,   292,   848,
       1,     1,     1,     1,   264,   265,   266,   924,     1,  1075,
    1076,   292,  1213,     1,  1034,     1,  1036,     1,     1,     1,
       1,  1013,  1014,  1089,   941,     1,   943,     1,   945,     1,
       1,     1,   949,     1,     1,     1,     1,     1,     1,     1,
       1,     1,  1034,     1,  1036,     1,     1,     1,   277,     1,
       1,     1,   313,   314,   315,  1075,  1076,     1,  1124,     1,
       1,    14,    15,     1,     1,     1,  1213,     1,     1,  1089,
       1,     1,  1138,   325,   326,   924,     1,   292,  1144,     1,
     292,   292,     1,  1075,  1076,     1,     1,     1,     1,  1319,
       1,     1,   941,     1,   943,   292,   945,  1089,   326,   328,
     949,   535,   331,   312,  1124,   337,   337,   339,   325,   326,
     327,   328,   329,  1138,   313,   329,   325,   328,  1138,  1144,
       1,   337,   339,  1498,  1144,   339,   325,   326,   327,   328,
     329,   325,   326,   336,   328,   329,  1202,   336,   339,   337,
     339,   313,   337,   336,   339,   339,  1138,   292,   328,   337,
       0,   339,  1144,   325,   326,   327,   328,   329,   337,  1076,
     339,   336,   338,   313,  1013,  1014,   337,   339,   339,   336,
    1492,   336,  1089,   336,   334,   325,   326,   327,   328,   329,
     335,   336,  1202,   292,   336,  1034,   336,  1036,   336,   339,
     336,     1,   336,   326,   336,  1416,   326,   831,   328,   326,
     834,   328,  1423,   837,   336,   336,   840,   336,   325,   326,
    1202,   328,   329,   336,   848,     1,     1,   336,   335,     1,
    1286,   336,   339,   336,   325,   858,  1075,  1076,   328,   325,
     326,   336,   328,   329,   336,   325,   326,   336,   328,   329,
    1089,   336,   336,   339,   336,   336,   325,   336,   336,   339,
     336,   325,   326,   328,   328,   329,   335,  1323,  1324,  1325,
    1326,  1286,   328,  1638,  1330,   339,  1286,   325,   336,   336,
    1336,   329,   336,   312,   325,   326,   327,   328,   329,   328,
     326,   339,   328,   292,   325,  1202,   325,   328,   339,  1138,
     924,   326,   326,   328,  1286,  1144,   335,     1,  1323,  1324,
    1325,  1326,   325,  1323,  1324,  1325,  1326,   941,   328,   943,
    1330,   945,     1,   328,   325,   949,  1336,   328,    16,   328,
     953,   326,   326,   328,   328,   326,   326,   328,   328,   328,
     328,  1323,  1324,  1325,  1326,   328,     1,   325,  1330,    21,
     326,   325,   328,   326,  1336,   328,   328,   328,   337,     1,
     292,     1,   328,  1202,   328,   292,   328,   328,   328,     1,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   325,
     328,     1,  1573,   328,   328,     1,   328,   328,   328,   312,
    1014,   325,   326,   327,   325,   326,   327,   325,   326,   325,
     312,   325,   325,   312,   325,   325,   312,   312,   312,   312,
     325,   312,   312,   325,   827,   313,   325,     1,     1,   325,
     325,   325,   325,  1330,   325,   325,     1,   325,     1,  1336,
       1,     1,     1,     1,     1,  1491,  1492,     1,     1,     1,
       1,   312,     1,     1,     1,     1,     1,  1286,     1,     1,
       1,     1,  1076,     1,   325,  1078,     1,   292,     1,  1082,
       1,     1,     1,     1,     1,  1089,     1,     1,     1,     1,
    1526,  1527,  1528,  1529,     1,     1,    62,     1,     1,   292,
       1,  1491,  1492,     1,  1323,  1324,  1325,  1326,     1,     1,
     292,  1330,     1,     1,   333,   292,   335,  1336,   831,     1,
    1124,   834,     1,     1,   837,     1,     1,   840,     1,  1491,
    1492,     1,   312,     1,  1138,   848,  1526,  1527,  1528,  1529,
    1144,     1,     1,     1,     1,   325,     1,    56,    57,     1,
       1,  1587,     1,     1,   874,   875,   876,   312,     1,     1,
     312,     1,     1,     1,  1526,  1527,  1528,  1529,     1,   325,
     325,     1,     1,   325,   325,   326,   292,   328,     1,    62,
     900,     1,     1,     1,     1,     1,     1,     1,   908,   909,
       1,   292,  1587,    62,   333,    62,   335,  1587,  1202,    62,
     292,   292,     1,  1639,  1491,  1492,  1642,  1643,     1,     1,
       1,   924,     1,     1,   333,   325,   335,  1653,  1654,  1655,
     292,  1657,  1658,  1659,   333,  1587,   335,     1,   941,   333,
     943,   335,   945,   328,   292,  1060,   949,     1,   312,  1526,
    1527,  1528,  1529,     1,  1639,   292,     1,  1642,   292,  1639,
       1,   325,  1642,  1643,  1074,     1,   333,   328,   335,  1654,
    1655,     1,  1082,  1653,  1654,  1655,   325,  1657,  1658,  1659,
       1,   292,  1491,  1492,   292,   292,     1,  1639,   313,   292,
    1642,  1643,  1286,   292,   292,     1,     1,  1007,  1008,  1009,
     325,  1653,  1654,  1655,     1,  1657,  1658,  1659,     1,     1,
       1,  1014,  1095,   325,  1097,   325,  1099,  1526,  1527,  1528,
    1529,     1,  1032,   325,    88,    89,    90,    91,  1143,  1323,
    1324,  1325,  1326,  1043,     1,   325,  1330,     1,     1,   325,
       1,     1,  1336,    88,    89,    90,    91,     1,     1,   292,
       1,     1,     1,   292,   325,   300,   301,   292,   325,     1,
     305,   306,   307,   308,   309,   310,  1643,     1,   292,   325,
       1,   325,   325,  1076,   325,     1,  1653,     1,  1587,     1,
    1657,  1658,  1659,     1,   325,   325,  1089,   325,   325,     1,
     342,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   292,   325,   325,   325,   325,   292,   325,   292,   325,
     325,  1121,   325,   292,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   326,   340,   328,   325,   325,
    1639,   325,   325,  1642,  1643,  1138,   292,   325,   333,   338,
     335,  1144,   325,   325,  1653,  1654,  1655,   325,  1657,  1658,
    1659,   325,   325,   325,   325,   325,   325,   325,   292,   325,
     325,   292,   325,   325,   292,   325,   325,   325,   325,  1179,
    1180,  1181,   325,   292,   292,   325,   325,   325,   325,   292,
     325,  1191,  1192,   325,   325,   325,   325,   325,   325,   326,
     292,   328,   325,   325,  1204,   325,   325,  1491,  1492,  1202,
    1210,  1211,   325,  1213,   325,   325,  1499,  1217,  1218,  1219,
    1220,  1221,  1222,  1223,   292,   325,   325,   325,   325,   325,
     325,   325,   292,   292,   325,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1526,  1527,  1528,  1529,   325,   333,   292,   335,
     292,   292,   325,   325,   325,   333,   325,   335,   333,   313,
     335,   325,   300,   301,   302,   292,   292,   305,   306,   300,
     301,   302,   325,   292,   305,   306,   325,   326,   313,   328,
     300,   301,   302,  1013,   292,   305,   306,   292,   292,   300,
     301,   292,   292,  1286,   305,   306,   292,   292,   292,   220,
     221,   222,   223,  1587,  1034,   292,  1036,   292,   292,   292,
     292,   292,   292,  1313,    88,    89,    90,    91,   333,   292,
     335,     1,   292,   300,   301,  1430,   292,   292,   305,   306,
    1323,  1324,  1325,  1326,   333,   292,   335,  1330,   292,   292,
     312,   292,   292,  1336,   312,  1075,   292,   292,   292,   292,
     322,   292,   292,   292,   322,  1639,   312,   292,  1642,  1643,
     292,   333,   333,   335,   335,   333,   322,   335,   292,  1653,
    1654,  1655,   292,  1657,  1658,  1659,   292,   333,   292,   335,
     292,   333,   292,   335,   292,   311,   312,   313,   314,   315,
     292,    71,    72,    73,    74,   333,    76,   335,    78,   292,
      80,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   292,   292,   312,   312,   292,   292,   325,
     326,   327,   328,   329,   292,   322,   322,   292,   326,  1522,
     336,   292,  1525,   339,   337,   292,   333,   333,   335,   335,
     292,   292,  1567,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   325,   326,   327,   328,
     329,   333,   292,   335,   292,   292,   292,   292,  1491,  1492,
     339,   292,  1502,   292,   292,   335,   292,   292,  1508,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   292,  1526,  1527,  1528,  1529,   292,   292,   313,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   292,
     292,   325,   326,   327,   328,   329,   292,   292,   292,   292,
     292,   292,   336,   292,   292,   339,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,     0,     1,   292,  1584,   292,   292,   292,   292,   292,
     292,   292,  1592,   292,  1587,    14,    15,    16,    17,    18,
      19,    20,    21,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    38,
     292,   292,    41,    42,    43,    44,    45,   292,   292,   292,
     292,   292,   292,   292,   325,   325,   325,   325,    57,   325,
     325,   325,   325,   325,   325,   337,  1639,   325,   325,  1642,
    1643,   325,   325,   109,   333,   325,   325,   325,   325,   325,
    1653,  1654,  1655,   339,  1657,  1658,  1659,   325,   325,   325,
     325,   325,   322,   292,   292,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     333,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   337,   337,   337,   329,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   342,   262,   263,   342,   333,   292,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   325,   332,
     292,   340,   325,   333,   335,   340,   328,   336,   340,   292,
     289,   290,   291,   334,   334,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   336,   336,
     336,   336,   336,   336,   325,   336,   336,   326,   336,   336,
     322,   340,   337,   322,   340,   334,   340,   335,   340,   333,
     337,     1,   341,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   342,   342,   336,   336,   328,
     335,   335,    22,    23,    24,    25,    26,    27,    28,    29,
     335,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   335,    42,   335,   335,   335,    46,   335,    48,    49,
      50,    51,    52,    53,    54,    55,   335,   322,    58,    59,
      60,   336,   339,   337,    64,    65,    66,    67,    68,    69,
       1,   337,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,   337,   337,   261,   261,   325,   335,
     335,    22,    23,    24,    25,    26,    27,    28,    29,   335,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     335,    42,   335,   326,   335,    46,   292,    48,    49,    50,
      51,    52,    53,    54,    55,   292,   292,    58,    59,    60,
     292,   335,   338,    64,    65,    66,    67,    68,    69,     1,
     339,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,   335,   333,   335,   333,   335,    47,   342,
      22,    23,    24,    25,    26,    27,    28,    29,   333,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,   335,
      42,   335,   335,   335,    46,   335,    48,    49,    50,    51,
      52,    53,    54,    55,   335,   335,    58,    59,    60,   335,
     335,   335,    64,    65,    66,    67,    68,    69,     1,   335,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,   335,   335,   335,   335,   335,   335,   335,    22,
      23,    24,    25,    26,    27,    28,    29,   335,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,   335,    42,
     335,   335,   335,    46,   335,    48,    49,    50,    51,    52,
      53,    54,    55,   335,   335,    58,    59,    60,   335,   335,
     335,    64,    65,    66,    67,    68,    69,   277,   335,   335,
     335,   335,   342,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   326,   340,   333,   328,
     328,   292,   322,   322,   335,   339,   326,   325,   335,   325,
     330,   331,   325,   333,   334,   335,   336,   337,   325,   325,
     325,   325,   342,   325,   325,   325,   277,   325,   325,   325,
     325,   325,   322,   314,   342,   328,   335,   325,   192,   328,
     856,  1181,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   335,   338,   335,   335,   335,
     335,   335,   335,   335,   335,   326,   335,   335,   335,   330,
     331,   335,   333,   334,   335,   336,   337,   335,   335,   335,
     335,   342,   335,   335,   335,   277,   335,   335,   335,   335,
     335,   335,   342,   335,   335,   335,   335,   340,   335,   335,
     953,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   342,   342,   340,   340,   825,   827,
     342,   342,   355,  1136,   326,   356,  1568,   531,   330,   331,
    1183,   333,   334,   335,  1584,   337,  1183,  1314,    -1,  1506,
     342,    -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1592,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,     1,
     333,   334,   335,    -1,   337,    -1,    -1,    -1,    -1,   342,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   335,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,    -1,
     262,   263,    -1,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   289,   290,   291,
      -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,    -1,    -1,     1,   326,     3,     4,     5,     6,     7,
      -1,    -1,   334,    -1,    12,    13,    14,   335,    -1,   341,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,   277,
     278,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,    -1,    -1,    -1,    -1,   336,   337,
      -1,   339,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   277,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   326,    -1,    -1,    -1,   330,
     331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   335,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,
      -1,    -1,   334,    -1,    -1,    -1,   338,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,    -1,   338,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,   277,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,     1,   338,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,   277,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,     1,   338,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,   277,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,
     330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,
      -1,    -1,   330,   331,    -1,    -1,   334,    -1,    -1,     1,
     338,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,   277,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334,    -1,    -1,     1,   338,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,   277,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,
      -1,    -1,   334,    -1,    -1,     1,   338,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,   277,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,    -1,
      -1,   334,    -1,    -1,    -1,   338,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,
     334,    -1,    -1,    -1,   338,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,
      -1,    -1,   334,    -1,    -1,     1,   338,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,   277,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,
      -1,     1,   338,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,   277,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,
      -1,     1,   338,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,   277,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,
     330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,
     331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,
     330,   331,    -1,    -1,   334,    -1,    -1,     1,   338,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,   313,
      -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,   313,    -1,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,    -1,   330,   331,    -1,    -1,    -1,   335,   336,   337,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,   335,   336,   337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,   335,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,   314,    -1,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,
     337,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,    -1,   330,   331,    -1,
      -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,
     336,   337,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
      -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,    -1,   330,   331,
      -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,   337,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,
     337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,    -1,   330,   331,    -1,
      -1,    -1,    -1,   336,   337,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,
     336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
      -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,    -1,   330,   331,
      -1,    -1,    -1,    -1,   336,   337,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,    -1,   336,   337,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,
     337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,    -1,   330,   331,    -1,
      -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,
     336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
      -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,    -1,   330,   331,
      -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,
      -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,    -1,
     337,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,   277,   278,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    41,    42,    43,    44,    45,
      57,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   262,   263,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   289,   290,   291,   326,   334,
     341,   344,   345,   346,   347,   348,   349,   350,   351,   362,
     366,   369,   370,   372,   373,   383,   384,   393,   292,     1,
     339,     1,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,     1,   328,     1,
     292,   328,     1,   336,     1,   292,   328,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,     1,
     292,     1,   292,     1,   292,     1,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,     1,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   322,   292,   292,   292,
     292,   292,   292,   292,   292,     1,   326,   328,   363,   364,
     365,     1,   365,   367,   368,     1,   328,     1,   328,     1,
     328,     0,     1,   346,    14,    15,   379,   380,    16,   381,
     382,    19,   387,   388,    20,   389,   390,    21,   391,   392,
     322,   339,   337,   325,   326,   328,   378,     1,   325,     1,
     325,     1,    88,    89,    90,    91,   313,   355,     1,   312,
     325,   361,     1,   325,     1,   325,     1,   361,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   326,     1,   328,
       1,   325,     1,   328,     1,   325,     1,   328,     1,   328,
       1,   328,     1,   328,     1,   325,   326,   327,   328,   329,
     336,   339,   352,   354,   355,   359,   360,   374,   375,   376,
     377,   407,   408,     1,   360,     1,   325,     1,   325,     1,
     325,   325,   325,   325,   361,   361,   361,   361,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,     1,   361,     1,   325,   328,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   361,     1,   361,     1,   361,
       1,   361,     1,   361,     1,   361,     1,   361,     1,   325,
       1,   325,     1,   328,     1,   328,     1,   325,     1,   328,
     328,     1,   328,     1,   325,     1,   325,     1,   326,   328,
       1,   326,   328,     1,   326,   328,     1,   326,   328,     1,
     326,   328,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   361,     1,   361,     1,   361,     1,   326,   328,     1,
     325,     1,   325,     1,   325,     1,   325,   375,     1,   377,
       1,   325,     1,   325,   325,   325,   325,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   220,   221,   222,   223,     1,   325,     1,
     325,     1,   325,     1,   325,     1,   328,     1,   328,     1,
     328,     1,   325,     1,   325,     1,   325,     1,   352,     1,
     325,     1,   325,     1,   325,     1,   325,     1,   325,     1,
     325,     1,   325,     1,   325,     1,   325,     1,   325,     1,
     325,     1,   325,     1,   325,     1,   325,     1,   325,     1,
     326,   328,     1,   325,   326,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   328,     1,   325,     1,   325,     1,   325,   264,   265,
     266,   325,   325,     1,   361,     1,   361,     1,   325,     1,
     325,     1,   325,     1,   325,   333,   342,   333,     1,   339,
       1,   337,     1,   339,   337,     1,   339,   337,     1,   339,
     337,     1,   339,    57,   325,   326,   371,   325,   385,   340,
     325,   322,   352,   353,   376,   342,   342,   360,   109,   312,
     322,   333,   292,   292,   292,   363,   325,   367,   378,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    22,    23,    24,    25,    26,    27,    28,    29,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    42,
      46,    48,    49,    50,    51,    52,    53,    54,    55,    58,
      59,    60,    64,    65,    66,    67,    68,    69,   277,   326,
     330,   331,   334,   409,   411,   412,   413,   417,   418,   426,
     427,   429,   430,   433,   434,   436,   440,   441,   442,   446,
     378,   411,   378,   411,   378,   411,   332,   292,   340,   411,
       1,   386,   325,   333,   335,   340,     1,   313,   325,   357,
     354,   352,     1,   325,   407,     1,   407,   328,     1,   328,
       1,   328,     1,   328,   340,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,   278,   312,   316,   318,   319,   320,   321,
     323,   324,   328,   336,   337,   361,   399,   400,   401,   402,
     403,   404,   409,   421,   426,   427,   428,   429,   431,   433,
     434,   437,   438,   439,   336,   439,   336,   439,     1,   336,
       1,   336,     1,   336,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   336,     1,   336,     1,
     336,   336,     1,   336,     1,   336,     1,   336,     1,   336,
     336,   336,   336,   336,   336,   336,   439,     1,   336,     1,
     336,     1,   336,   336,   336,   336,   336,     1,   439,   439,
       1,   336,     1,   336,     1,   336,     1,   336,     1,   336,
       1,   443,     1,   334,     1,   338,   412,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   326,   423,   424,   425,
     292,   435,   334,     1,   336,   334,   340,   338,   340,   338,
     340,   338,   340,     1,   325,   328,   322,   338,   337,   322,
     353,   342,   342,   333,   337,     1,    61,   326,   328,   335,
     374,   406,     1,    61,   328,   374,   406,     1,    61,   328,
     374,   406,     1,    61,   328,   374,   406,     1,    61,   328,
     374,   406,     1,   300,   301,   302,   305,   306,   394,   396,
     394,   394,     1,   394,   422,     1,   439,     1,   439,     1,
     439,   336,   336,     1,   335,   427,   429,   433,   434,   439,
     440,     1,   411,     1,   396,     1,   307,   308,   309,   310,
     394,   395,     1,   396,   425,     1,   439,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     397,   398,   335,   335,     1,   325,   328,     1,   328,     1,
     326,   439,   328,     1,   328,     1,   328,     1,   328,     1,
     328,     1,   325,     1,   325,   335,     1,   335,   361,   335,
       1,   328,     1,   328,     1,   328,     1,   328,   335,   335,
     335,     1,   325,   335,     1,   355,   337,   410,   412,     1,
     352,     1,   325,     1,   352,   355,   358,   335,   335,   335,
     335,   337,   410,     1,   328,     1,   328,   325,   365,   325,
     365,   325,   365,   336,   322,   339,   439,     1,   328,   426,
     427,   432,   434,   337,   337,   337,   337,   261,   261,   371,
     411,   325,   357,   325,   328,   361,   411,   335,   333,   335,
     333,   335,   333,   335,   312,   322,   333,   335,   335,   333,
     335,   333,   335,   333,   335,   333,   335,   335,   333,   335,
     333,   335,   333,   335,   333,   335,   335,   333,   335,   333,
     335,   333,   335,   333,   335,   335,   333,   335,   333,   335,
     333,   335,   333,   335,     1,   326,   439,     1,    88,    89,
      90,    91,    92,    93,   313,   356,   439,     1,   356,   439,
       1,   399,   403,   326,   419,   420,     1,   439,     1,   439,
     335,   335,   335,   338,   338,     1,    86,   439,     1,   439,
       1,   439,     1,    86,   325,   326,   374,   405,   406,   439,
     339,     1,   439,     1,   439,     1,   439,     1,   439,   439,
     439,   439,     1,   439,     1,   439,     1,   439,     1,   439,
       1,   439,     1,   439,     1,   439,   335,   333,   335,   335,
     333,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   411,    47,   335,   335,   335,   335,   335,   342,   342,
     335,     1,    56,    57,   338,   415,   416,   335,   333,   335,
     335,   335,   335,   335,   335,   335,   335,   439,   444,   445,
     424,   340,   333,   335,   425,   333,   411,   411,   411,   411,
     328,   328,   292,   338,   322,   335,   335,   338,    62,   325,
     325,   325,     1,   326,     1,   326,   325,    62,   325,   325,
     325,   325,    62,   325,   325,   325,   325,    62,   325,   325,
     325,   325,    62,   325,   325,   325,   325,   339,   322,   335,
     335,   335,   335,   314,   361,   328,   328,   338,   410,     1,
     357,   352,   338,     1,   314,   414,   439,   342,   338,   415,
     325,   439,   333,   335,   365,     1,   365,   338,   338,   338,
     338,   325,   328,   325,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   328,
     361,   419,     1,   325,   374,   340,   335,   335,   342,   342,
       1,   414,   342,   411,   335,   335,   445,   335,   335,   335,
     340,   340,   357,   411,   342,   342,     1,   411,   411,   411
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   343,   344,   345,   345,   345,   346,   346,   346,   346,
     346,   347,   346,   348,   346,   346,   349,   346,   350,   346,
     351,   346,   346,   346,   352,   352,   352,   353,   353,   354,
     354,   355,   355,   355,   355,   355,   356,   356,   356,   356,
     356,   356,   356,   357,   357,   358,   358,   358,   358,   358,
     359,   359,   359,   359,   359,   360,   360,   361,   361,   362,
     362,   363,   363,   364,   364,   365,   365,   366,   366,   367,
     367,   368,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   370,   370,   371,   371,   371,
     372,   372,   372,   372,   372,   372,   372,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     374,   374,   375,   376,   377,   377,   378,   378,   378,   379,
     379,   380,   380,   380,   380,   381,   382,   382,   382,   383,
     383,   385,   384,   384,   384,   386,   384,   384,   387,   388,
     388,   388,   389,   390,   390,   390,   391,   392,   392,   393,
     393,   393,   393,   393,   393,   394,   394,   394,   394,   395,
     395,   395,   395,   396,   396,   397,   397,   397,   397,   397,
     397,   397,   398,   398,   398,   398,   399,   399,   399,   400,
     400,   400,   401,   401,   401,   401,   401,   402,   402,   403,
     403,   403,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   405,   405,   405,   405,   406,   406,   406,   406,   406,
     407,   407,   407,   408,   408,   408,   408,   408,   409,   410,
     410,   411,   411,   411,   412,   412,   412,   412,   412,   412,
     412,   412,   413,   413,   414,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   416,   416,   417,   417,
     417,   417,   418,   419,   419,   419,   420,   420,   422,   421,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   424,
     425,   425,   426,   427,   428,   429,   430,   430,   431,   431,
     431,   432,   432,   432,   433,   434,   435,   436,   436,   436,
     437,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   438,   438,   438,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   440,   441,   441,   441,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   443,   442,   442,   444,   444,   444,   445,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     7,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     5,     5,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     2,     1,     1,     1,     1,     1,
       5,     5,     7,     7,     5,     8,     8,     2,     2,     2,
       2,     3,     3,     8,     8,     2,     2,     2,     3,     3,
       1,     1,     7,     1,     1,     3,     1,     1,     1,     1,
       1,     4,     7,     2,     2,     1,     4,     7,     2,     1,
       1,     0,     5,     2,     2,     0,     8,     5,     1,     4,
       7,     2,     1,     4,     7,     2,     1,     7,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     2,     3,     3,     3,     2,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       2,     3,     3,     1,     3,     1,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     1,
       3,     2,     1,     2,     2,     1,     1,     1,     2,     2,
       1,     2,     3,     5,     1,     4,     5,     3,     4,     3,
       2,     4,     5,     3,     4,     4,     2,     1,     5,     4,
       2,     5,     3,     1,     4,     4,     3,     1,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     1,     1,     1,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     4,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     4,     4,     2,     3,     1,     1,     1,     3,     4,
       4,     4,     6,     6,     6,     6,     6,     4,     2,     4,
       4,     4,     4,     6,     6,     6,     6,     6,     4,     2,
       4,     4,     4,     4,     6,     6,     6,     6,     6,     4,
       2,     4,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     6,     2,     4,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     6,     6,     6,
       4,     2,     6,     2,     4,     4,     4,     2,     4,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     3,     2,     4,     3,     2,     4,     3,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     3,     1,     3,
       1,     3,     1,     4,     3,     1,     4,     4,     4,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     3,     1,
       3,     1,     3,     1,     3,     1,     6,     6,     2,     4,
       4,     2,     4,     0,     5,     2,     0,     3,     1,     1,
       3,     2,     1,     3,     2,     1,     1,     3,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 622 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 623 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 624 "core/cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 5016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 632 "core/cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 5022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 633 "core/cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 5028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 635 "core/cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 5034 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 636 "core/cfg.y" /* yacc.c:1646  */
    {rt=ONSEND_ROUTE;}
#line 5040 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 637 "core/cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 5046 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 642 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					LM_CRIT("cfg. parser: out of memory.\n");
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
#line 5067 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 658 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: out of memory.\n");
		} else {
				strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
		}
	}
#line 5080 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 666 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					LM_CRIT("cfg. parser: out of memory.\n");
			} else {
					strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
			}
		}
	}
#line 5095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 680 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 681 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 687 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5115 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 688 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5121 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 692 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5127 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 693 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5133 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 694 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5139 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 695 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5145 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 696 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 699 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 700 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 701 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 702 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 703 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 704 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 705 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 708 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 5199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 709 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 712 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 713 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 714 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 715 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 720 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 721 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 722 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 723 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 724 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 728 "core/cfg.y" /* yacc.c:1646  */
    {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 729 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 733 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 737 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("flag list expected\n"); }
#line 5289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 743 "core/cfg.y" /* yacc.c:1646  */
    { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 746 "core/cfg.y" /* yacc.c:1646  */
    {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5306 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 752 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5312 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 753 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5318 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 758 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("avpflag list expected\n"); }
#line 5324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 765 "core/cfg.y" /* yacc.c:1646  */
    {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 771 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 772 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 5345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 773 "core/cfg.y" /* yacc.c:1646  */
    { dont_fork= ! (yyvsp[0].intval); }
#line 5351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 774 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 775 "core/cfg.y" /* yacc.c:1646  */
    { set_fork_delay((yyvsp[0].intval)); }
#line 5363 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 776 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5369 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 777 "core/cfg.y" /* yacc.c:1646  */
    { set_modinit_delay((yyvsp[0].intval)); }
#line 5375 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 778 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 779 "core/cfg.y" /* yacc.c:1646  */
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5389 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 782 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5395 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 783 "core/cfg.y" /* yacc.c:1646  */
    {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 789 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 5412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 790 "core/cfg.y" /* yacc.c:1646  */
    { log_name=(yyvsp[0].strval); }
#line 5418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 791 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 792 "core/cfg.y" /* yacc.c:1646  */
    { log_color=(yyvsp[0].intval); }
#line 5430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 793 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 794 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_fmt=(yyvsp[0].strval); }
#line 5442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 795 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 796 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_mode=(yyvsp[0].intval); }
#line 5454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 797 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 798 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_type=(yyvsp[0].strval); }
#line 5466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 799 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5472 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 800 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_data=(yyvsp[0].strval); }
#line 5478 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 801 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5484 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 802 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5492 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 805 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5498 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 806 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 809 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5512 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 810 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5518 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 811 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 812 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5530 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 813 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 814 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 815 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 816 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 817 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5560 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 818 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5566 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 819 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5572 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 820 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5578 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 821 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5584 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 822 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 823 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 824 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 825 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 826 "core/cfg.y" /* yacc.c:1646  */
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 5615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 828 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 829 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 5627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 830 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 831 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 5639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 832 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 833 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 5651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 834 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 835 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 5663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 836 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5669 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 837 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 5675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 838 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 839 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 5687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 840 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 841 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 5699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 842 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 843 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 5711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 844 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 845 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 5723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 846 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 847 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 5735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 848 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 849 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 5747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 850 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 851 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 5759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 852 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 853 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 5771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 854 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 855 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 5783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 856 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 857 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 5795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 858 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 859 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 5807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 860 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 861 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 5819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 862 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 863 "core/cfg.y" /* yacc.c:1646  */
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 5831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 864 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 865 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[0].intval)); }
#line 5843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 866 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 867 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[0].intval));
	}
#line 5857 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 870 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5863 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 871 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 5871 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 874 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5877 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 875 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 5885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 878 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 879 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 5897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 880 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5903 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 881 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 5911 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 884 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5917 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 885 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 5925 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 888 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5931 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 889 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 5939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 892 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 893 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 5953 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 896 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 897 "core/cfg.y" /* yacc.c:1646  */
    { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 5965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 898 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 5971 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 899 "core/cfg.y" /* yacc.c:1646  */
    { port_no=(yyvsp[0].intval); }
#line 5977 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 900 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef STATS
				stat_file=(yyvsp[0].strval);
		#endif
	}
#line 5987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 905 "core/cfg.y" /* yacc.c:1646  */
    { maxbuffer=(yyvsp[0].intval); }
#line 5993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 906 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 907 "core/cfg.y" /* yacc.c:1646  */
    { sql_buffer_size=(yyvsp[0].intval); }
#line 6005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 908 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 909 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 910 "core/cfg.y" /* yacc.c:1646  */
    { children_no=(yyvsp[0].intval); }
#line 6023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 911 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 912 "core/cfg.y" /* yacc.c:1646  */
    { socket_workers=(yyvsp[0].intval); }
#line 6035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 913 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 914 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers((yyvsp[0].intval)); }
#line 6047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 915 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 916 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 917 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 918 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 919 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 920 "core/cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 6083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 921 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6089 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 922 "core/cfg.y" /* yacc.c:1646  */
    { phone2tel=(yyvsp[0].intval); }
#line 6095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 923 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 924 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6107 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 925 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 926 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 927 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 928 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 929 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 930 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 931 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 932 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6155 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 933 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6161 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 934 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6167 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 935 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6173 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 936 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 937 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 938 "core/cfg.y" /* yacc.c:1646  */
    { sip_warning=(yyvsp[0].intval); }
#line 6191 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 939 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6197 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 940 "core/cfg.y" /* yacc.c:1646  */
    { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 943 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 944 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 951 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 958 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 959 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 960 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 961 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 962 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 963 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 964 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 965 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 966 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 967 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 968 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 969 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 970 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 971 "core/cfg.y" /* yacc.c:1646  */
    { mhomed=(yyvsp[0].intval); }
#line 6319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 972 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 973 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 980 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 981 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 988 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 989 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 996 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 997 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1004 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1005 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1012 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1013 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1023 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1024 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6455 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1038 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6474 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1052 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 6480 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1053 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6492 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1060 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6498 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1061 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6510 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1068 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6516 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1069 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6528 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1076 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6534 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1077 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1086 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv4 address expected"); }
#line 6554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1087 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1096 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv6 address expected"); }
#line 6574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1097 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6586 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1104 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6592 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1105 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6604 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1112 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1113 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6622 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1120 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6628 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1121 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6640 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1128 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1129 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1136 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1137 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1144 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1145 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1152 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1153 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1160 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1161 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1168 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1169 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1176 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1177 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1184 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected");}
#line 6772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1185 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1192 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1193 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6802 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1200 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6808 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1201 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6820 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1208 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6826 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1209 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6838 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1216 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6844 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1217 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6856 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1224 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6862 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1225 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6874 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1232 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6880 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1234 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6892 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1241 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1242 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6914 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1253 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6920 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1254 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6932 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1261 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1262 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6950 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1269 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1270 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 6968 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1277 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6974 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1278 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6986 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1285 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6992 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1286 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1293 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1300 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1307 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7040 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1314 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7052 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1321 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7064 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1328 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7070 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1329 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7082 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1336 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7088 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1337 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7100 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1344 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7106 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1345 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1352 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7124 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1353 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7136 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1360 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7142 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1361 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7154 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1368 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7160 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1369 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7172 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1376 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7178 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1377 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1384 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7196 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1385 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7208 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1392 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean or number expected"); }
#line 7214 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1393 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7226 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1400 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7232 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1401 "core/cfg.y" /* yacc.c:1646  */
    { server_signature=(yyvsp[0].intval); }
#line 7238 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1402 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7244 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1403 "core/cfg.y" /* yacc.c:1646  */
    { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7252 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1406 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7258 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1407 "core/cfg.y" /* yacc.c:1646  */
    { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7266 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1410 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7272 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1411 "core/cfg.y" /* yacc.c:1646  */
    { reply_to_via=(yyvsp[0].intval); }
#line 7278 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1412 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7284 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1413 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1425 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1438 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 7326 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1440 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7342 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1451 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 7348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1452 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 7354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1453 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7360 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1454 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 7371 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1460 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7377 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1461 "core/cfg.y" /* yacc.c:1646  */
    {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 7392 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1471 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7398 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1472 "core/cfg.y" /* yacc.c:1646  */
    { disable_core_dump=(yyvsp[0].intval); }
#line 7404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1473 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7410 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1474 "core/cfg.y" /* yacc.c:1646  */
    { open_files_limit=(yyvsp[0].intval); }
#line 7416 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1475 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7422 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1476 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 7434 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1483 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7440 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1484 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 7452 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1491 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7458 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1492 "core/cfg.y" /* yacc.c:1646  */
    { mlock_pages=(yyvsp[0].intval); }
#line 7464 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1493 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7470 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1494 "core/cfg.y" /* yacc.c:1646  */
    { real_time=(yyvsp[0].intval); }
#line 7476 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1495 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7482 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1496 "core/cfg.y" /* yacc.c:1646  */
    { rt_prio=(yyvsp[0].intval); }
#line 7488 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1497 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7494 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1498 "core/cfg.y" /* yacc.c:1646  */
    { rt_policy=(yyvsp[0].intval); }
#line 7500 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1499 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1500 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_prio=(yyvsp[0].intval); }
#line 7512 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1501 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7518 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1502 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_policy=(yyvsp[0].intval); }
#line 7524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1503 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7530 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1504 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_prio=(yyvsp[0].intval); }
#line 7536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1505 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1506 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_policy=(yyvsp[0].intval); }
#line 7548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1507 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1508 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7566 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1515 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7572 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1516 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7584 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1523 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1524 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1531 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7614 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1538 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1539 "core/cfg.y" /* yacc.c:1646  */
    { tos=(yyvsp[0].intval); }
#line 7626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1540 "core/cfg.y" /* yacc.c:1646  */
    { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 7658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1567 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1568 "core/cfg.y" /* yacc.c:1646  */
    { pmtu_discovery=(yyvsp[0].intval); }
#line 7670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1569 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1570 "core/cfg.y" /* yacc.c:1646  */
    { ser_kill_timeout=(yyvsp[0].intval); }
#line 7682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1571 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1572 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 7694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1573 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1574 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_size((yyvsp[0].intval)); }
#line 7706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1575 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1576 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 7718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1577 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1578 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 7730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1579 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1580 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 7742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1581 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1582 "core/cfg.y" /* yacc.c:1646  */
    { http_reply_parse=(yyvsp[0].intval); }
#line 7754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1583 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1584 "core/cfg.y" /* yacc.c:1646  */
    { ksr_verbose_startup=(yyvsp[0].intval); }
#line 7766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1585 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1586 "core/cfg.y" /* yacc.c:1646  */
    { ksr_route_locks_size=(yyvsp[0].intval); }
#line 7778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1587 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1588 "core/cfg.y" /* yacc.c:1646  */
    { server_id=(yyvsp[0].intval); }
#line 7790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1589 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7796 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1590 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 7810 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1599 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1600 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 7830 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1609 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7836 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1610 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 7850 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1619 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7856 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1620 "core/cfg.y" /* yacc.c:1646  */
    { set_max_recursive_level((yyvsp[0].intval)); }
#line 7862 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1621 "core/cfg.y" /* yacc.c:1646  */
    { sr_dst_max_branches = (yyvsp[0].intval); }
#line 7868 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1622 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 7874 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1623 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7880 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1624 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 7886 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1625 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7892 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1626 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 7898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1627 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1628 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 7910 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1629 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7916 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1630 "core/cfg.y" /* yacc.c:1646  */
    { sr_msg_time=(yyvsp[0].intval); }
#line 7922 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1631 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1632 "core/cfg.y" /* yacc.c:1646  */
    { onsend_route_reply=(yyvsp[0].intval); }
#line 7934 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1633 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7940 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1634 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 7946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1635 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7952 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1637 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 7958 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1638 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7964 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1640 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 7970 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1642 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 7976 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1643 "core/cfg.y" /* yacc.c:1646  */
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 7982 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1644 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7988 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1645 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 7996 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1648 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8002 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1649 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 8010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1652 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1654 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 8022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1658 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1662 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8034 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1663 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 8044 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1671 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8054 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1676 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8064 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1681 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8074 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1686 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8084 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1691 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("number or string expected");
	}
#line 8092 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1694 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8102 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1699 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1707 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_module((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8123 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1713 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1714 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8144 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1724 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8150 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1725 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1735 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1736 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1747 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1758 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 8209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1759 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8220 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1765 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8226 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1766 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1772 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1776 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1777 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1780 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 8287 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1809 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 8305 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1824 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8311 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1825 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 8317 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1829 "core/cfg.y" /* yacc.c:1646  */
    {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 8333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1840 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1841 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1845 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1846 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1850 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 8371 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1859 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 8394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1877 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 8400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1878 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  request_route  statement"); }
#line 8406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1881 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1884 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 8426 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1893 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 8449 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1911 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 8455 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1915 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8461 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1916 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8467 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1921 "core/cfg.y" /* yacc.c:1646  */
    {rt=CORE_ONREPLY_ROUTE;}
#line 8473 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1921 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 8487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1930 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1931 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1933 "core/cfg.y" /* yacc.c:1646  */
    {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 8505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1934 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 8533 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1957 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("invalid onreply_route statement");
	}
#line 8541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1962 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1965 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 8561 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1974 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 8584 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1992 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 8590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1995 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1998 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 8610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2007 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 8633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2025 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onsend_route statement"); }
#line 8639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2028 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2031 "core/cfg.y" /* yacc.c:1646  */
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 8668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2050 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 8674 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2053 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 8680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2054 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid subst preprocess statement"); }
#line 8686 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2055 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 0)<0) YYERROR; }
#line 8692 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2056 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdef preprocess statement"); }
#line 8698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2057 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 1)<0) YYERROR; }
#line 8704 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2058 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdefs preprocess statement"); }
#line 8710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2080 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 8716 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2081 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 8722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2082 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 8728 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2083 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 8734 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2086 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 8740 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2087 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 8746 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2088 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 8752 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2089 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 8758 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2092 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 8764 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2093 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 8770 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2099 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_EQ_OP; }
#line 8776 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2100 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_DIFF_OP; }
#line 8782 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2101 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IEQ_OP; }
#line 8788 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2102 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IDIFF_OP; }
#line 8794 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2103 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STREQ_OP; }
#line 8800 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2104 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STRDIFF_OP; }
#line 8806 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2105 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_MATCH_OP; }
#line 8812 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2108 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GT_OP; }
#line 8818 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2109 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LT_OP; }
#line 8824 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2110 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GTE_OP; }
#line 8830 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2111 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LTE_OP; }
#line 8836 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2118 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=URI_O;}
#line 8842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2119 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=FROM_URI_O;}
#line 8848 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2120 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=TO_URI_O;}
#line 8854 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2127 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDPORT_O; }
#line 8860 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2128 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=TOPORT_O; }
#line 8866 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2129 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDAF_O; }
#line 8872 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2133 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCPORT_O; }
#line 8878 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2134 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTPORT_O; }
#line 8884 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2135 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=AF_O; }
#line 8890 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2136 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=MSGLEN_O; }
#line 8896 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2142 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 8902 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2143 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 8908 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2146 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCIP_O; }
#line 8914 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2147 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTIP_O; }
#line 8920 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2155 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 8926 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2157 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 8932 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2158 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string expected"); }
#line 8938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2160 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 8944 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2162 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 8950 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2164 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 8956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2166 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 8962 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2168 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 8968 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2169 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 8974 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2171 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 8980 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2172 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 8986 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2173 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 8992 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2174 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 8998 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2176 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2178 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2180 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2182 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2184 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2186 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9034 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2187 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 9040 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2188 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 9081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2225 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 9087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2227 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2229 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 9099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2231 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 9105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2234 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2236 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2238 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 9123 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2239 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 9129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2243 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 9135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2244 "core/cfg.y" /* yacc.c:1646  */
    {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 9151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2255 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 9157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2256 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 9163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2260 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2261 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2277 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2293 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2294 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2299 "core/cfg.y" /* yacc.c:1646  */
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval))
				strcpy((yyval.strval), yy_number_str);
		}
#line 9234 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2308 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9240 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2309 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9261 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2325 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9282 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2341 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2343 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9296 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2350 "core/cfg.y" /* yacc.c:1646  */
    {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 9333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2392 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2393 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2396 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 9351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2397 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2398 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command"); }
#line 9363 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2401 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9369 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2402 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9375 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2403 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2404 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9387 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2405 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9393 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2406 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9399 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2407 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 9405 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2408 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 9411 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2411 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2419 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9437 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2429 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 9457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2446 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2453 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2460 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2467 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2474 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9515 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2479 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2484 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9531 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2485 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9537 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2486 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9543 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2487 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9549 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2488 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 9555 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2491 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 9569 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2500 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 9579 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2507 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2532 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9630 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2548 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 9636 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2550 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror ("bad switch body"); }
#line 9642 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2554 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 9657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2573 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 9671 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2582 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 9688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2594 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 9706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2613 "core/cfg.y" /* yacc.c:1646  */
    { sel.n = 0; sel.f[0] = 0; }
#line 9712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2613 "core/cfg.y" /* yacc.c:1646  */
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 9725 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2623 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM; }
#line 9731 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2624 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO; }
#line 9737 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2625 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 9743 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2626 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 9749 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2627 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 9755 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2628 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 9761 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2629 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 9767 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2630 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 9773 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2631 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 9779 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2634 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 9785 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2641 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else s_attr->type = 0;
	}
#line 9795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2648 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.attr) = s_attr; }
#line 9801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2651 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 9811 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2658 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 9820 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2680 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 9837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2692 "core/cfg.y" /* yacc.c:1646  */
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 9864 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2716 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 9878 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2727 "core/cfg.y" /* yacc.c:1646  */
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 9904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2758 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = ASSIGN_T; }
#line 9910 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2762 "core/cfg.y" /* yacc.c:1646  */
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 9925 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2772 "core/cfg.y" /* yacc.c:1646  */
    {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 9944 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2786 "core/cfg.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 9959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2798 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[0].intval)); }
#line 9965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2799 "core/cfg.y" /* yacc.c:1646  */
    {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 9972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2801 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 9978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2802 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 9984 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2803 "core/cfg.y" /* yacc.c:1646  */
    {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 10003 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2817 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 10009 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2818 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 10015 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2819 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 10021 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2820 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10027 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2821 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 10033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2822 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2823 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2827 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_LNOT_OP; }
#line 10051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2828 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_BNOT_OP; }
#line 10057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2829 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_UMINUS_OP; }
#line 10063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2842 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 10074 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2848 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 10080 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2849 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[0].rv_expr)); }
#line 10086 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2850 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 10092 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2851 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10098 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2852 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10104 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2853 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10110 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2854 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10116 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2855 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10122 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2856 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 10128 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2857 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10134 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2858 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10140 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2859 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10146 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2860 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10152 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2861 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10158 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2862 "core/cfg.y" /* yacc.c:1646  */
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 10181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2880 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2881 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2882 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 10199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2883 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 10205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2884 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 10211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2885 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 10217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2886 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2887 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2888 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2889 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2890 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2891 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2892 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2893 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2894 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2895 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2897 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2899 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2900 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2901 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2902 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2903 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2904 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2907 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 10328 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2925 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 1; }
#line 10334 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2926 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 0; }
#line 10340 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2927 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = -1; }
#line 10346 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2930 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10352 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2931 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2932 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2933 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2934 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2935 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10382 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2936 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2937 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2938 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2939 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2940 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2941 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward argument"); }
#line 10418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2942 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2943 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2944 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2945 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2946 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2947 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2948 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2949 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2950 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10472 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2951 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10478 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2952 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 10484 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2953 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10490 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2954 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 2955 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2956 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2957 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10514 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2958 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2959 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10526 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2960 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2961 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2962 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10544 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2963 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 10550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2964 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10563 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2972 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10576 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 2980 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10589 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 2988 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 2996 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3004 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 10628 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3012 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10641 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3020 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10654 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3028 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10667 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3036 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10673 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3037 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 10680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3039 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3047 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3055 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10719 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3063 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10733 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3072 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3081 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 10761 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3090 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10774 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3098 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10788 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3107 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3115 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3116 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 10814 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3118 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 10822 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3121 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 10828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3122 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10834 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3123 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log argument"); }
#line 10840 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3124 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 10852 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3131 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 10864 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3138 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10870 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3139 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 10881 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3145 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 10893 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3152 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10899 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3153 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 10910 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3159 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 10922 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3166 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3167 "core/cfg.y" /* yacc.c:1646  */
    {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 10939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3173 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 10947 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3176 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 10955 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3179 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad parameters"); }
#line 10961 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3180 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10967 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3181 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 10975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3184 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3185 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error argument"); }
#line 10987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3186 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11001 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3195 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11015 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3204 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11021 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3205 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route argument"); }
#line 11027 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3206 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3207 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3208 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3209 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3210 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3211 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3212 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3213 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3214 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3215 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3216 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3217 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3218 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3219 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 11111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3220 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3221 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 11126 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3225 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 11135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3229 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11141 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3230 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3231 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 11153 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3232 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11159 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3233 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3234 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3235 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3236 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3237 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3238 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11195 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3239 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3240 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3241 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3242 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11219 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3243 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11225 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3244 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3245 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3246 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3247 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3248 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3249 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11261 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3250 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11267 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3251 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3252 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3253 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3254 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3255 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3256 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11310 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3264 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11323 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3272 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11336 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3280 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11342 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3282 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3284 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 11354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3285 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 11370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3296 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3297 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11382 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3298 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				LM_CRIT("cfg. parser: out of memory.\n");
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 11403 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3314 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3315 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3316 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 11424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3320 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 11432 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3323 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11438 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3324 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11446 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3327 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3330 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11462 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3333 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11470 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3336 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11478 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3339 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11486 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3342 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11494 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3345 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3348 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 11510 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3351 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 11518 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3354 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3355 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 11530 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3356 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 11538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3359 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11544 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3360 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 11550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3361 "core/cfg.y" /* yacc.c:1646  */
    {mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST,
			0); }
#line 11557 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3362 "core/cfg.y" /* yacc.c:1646  */
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				free_mod_func_action(mod_func_action);
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
	}
#line 11587 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3387 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("'('')' expected (function call)");}
#line 11593 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3391 "core/cfg.y" /* yacc.c:1646  */
    { }
#line 11599 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3392 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 11605 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3395 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 11624 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3412 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3416 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11642 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3420 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3424 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11661 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3429 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3433 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3438 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11689 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3442 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3446 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11707 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3450 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11716 "core/cfg.tab.c" /* yacc.c:1646  */
    break;


#line 11720 "core/cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3456 "core/cfg.y" /* yacc.c:1906  */


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		LM_CRIT("cfg. parser: out of memory.\n");
	} else {
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LM_CRIT("cfg. parser: out of memory.\n");
	} else {
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LM_CRIT("cfg. parser: out of memory.\n");
	} else {
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
